;=============== data, methods and fields of alternative players ===============

altplayers .block

CopyPlayer ;copy the selected player into place of the default
		asl
		tax
		lda PlrAddr+0,x
		sta datzptr+0
		lda PlrAddr+1,x
		sta datzptr+1
		lda #<PLAYERADDR
		ldx #>PLAYERADDR
		sta inszptr+0
		stx inszptr+1
		ldx #>(MAX_PLAYERSIZE)
		ldy #0
-		lda (datzptr),y
		sta (inszptr),y
		iny
		bne -
		inc datzptr+1
		inc inszptr+1
		dex
		bne -
		rts

SetFreqTb ;if needed, change to NTSC table
		asl
		tax ;x points to selected player's freq.table address
		lda PALNTSC
		bne retfrtb ;if PAL, no need to modify
		lda frqtHaddr+0,x
		sta datzptr+0
		lda frqtHaddr+1,x
		sta datzptr+1
		lda frqtLaddr+0,x
		sta vidzptr+0
		lda frqtLaddr+1,x
		sta vidzptr+1
		ldy #12*8-1-1
-		lda FreqTableNtscHi,y
		sta (datzptr),y
		lda FreqTableNtscLo,y
		sta (vidzptr),y
		dey
		bpl -
retfrtb	rts

PlrAddr	.if COMPILEDAPP==1
		 .word player.playercode ;default player isn't overwritten in editor
		.else
		 .word normalPlayer.playercode
		.fi 
		.word mediumPlayer.playercode, lightPlayer.playercode, extraPlayer.playercode

;frequency-table addresses in players (SID-Wizard C-1 note starts from 1, not 0)
frqtHaddr .word player.FREQTBH+1, mediumPlayer.FREQTBH+1, lightPlayer.FREQTBH+1, extraPlayer.FREQTBH+1
frqtLaddr .word player.FREQTBL+1, mediumPlayer.FREQTBL+1, lightPlayer.FREQTBL+1, extraPlayer.FREQTBL+1

		.if COMPILEDAPP==1
descrAddr .word normalPlayer.description, mediumPlayer.description, lightPlayer.description, extraPlayer.description
FeatIadd .word normalPlayer.FeatInstance1, mediumPlayer.FeatInstance1, lightPlayer.FeatInstance1, extraPlayer.FeatInstance1
rastimes .text"$1C ","$1B ","$15 ","$23 "
plysizes .text"$A36","$97A","$7DA","$ACF" ;.text ^(player.playercode_end-player.playercode), ^(mediumPlayer.playercode_end-mediumPlayer.playercode), text ^(lightPlayer.playercode_end-lightPlayer.playercode), ^(extraPlayer.playercode_end-extraPlayer.playercode)
		.fi

		.if COMPILEDAPP==2
PlrEnds	.word normalPlayer.player_top, mediumPlayer.player_top, lightPlayer.player_top, extraPlayer.player_top ;these pointers are  to logical address equivalents of 'playercode_end'
PlrDatP	.word normalPlayer.DataPtr, mediumPlayer.DataPtr, lightPlayer.DataPtr, extraPlayer.DataPtr
PlrValP .word normalPlayer.PtrValu, mediumPlayer.PtrValu, lightPlayer.PtrValu, extraPlayer.PtrValu
PlrRelo	.word normalPlayer.reloctable, mediumPlayer.reloctable, lightPlayer.reloctable, extraPlayer.reloctable
PlrFxPt	.word normalPlayer.BIGFXTABLE+1, mediumPlayer.BIGFXTABLE+1, lightPlayer.BIGFXTABLE+1, extraPlayer.BIGFXTABLE+1
		.fi

;---------------------------------------------------------------------------------------
;NTSC frequency table for NTSC machines
;------------------------------------------
FreqTableNtscHi
                ;      C   C#  D   D#  E   F   F#  G   G#  A   A#  B
                .byte $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01  ; 1
                .byte $02,$02,$02,$02,$02,$02,$02,$03,$03,$03,$03,$03  ; 2
                .byte $04,$04,$04,$04,$05,$05,$05,$06,$06,$07,$07,$07  ; 3
                .byte $08,$08,$09,$09,$0a,$0b,$0b,$0c,$0d,$0e,$0e,$0f  ; 4
                .byte $10,$11,$12,$13,$15,$16,$17,$19,$1a,$1c,$1d,$1f  ; 5
                .byte $21,$23,$25,$27,$2a,$2c,$2f,$32,$35,$38,$3b,$3f  ; 6
                .byte $43,$47,$4b,$4f,$54,$59,$5e,$64,$6a,$70,$77,$7e  ; 7
                .byte $86,$8e,$96,$9f,$a9,$b3,$bd,$c9,$d5,$e1,$ef,$fd  ; 8

FreqTableNtscLo
                ;      C   C#  D   D#  E   F   F#  G   G#  A   A#  B
                .byte $0c,$1c,$2d,$3f,$52,$66,$7b,$92,$aa,$c3,$de,$fa  ; 1
                .byte $18,$38,$5a,$7e,$a4,$cc,$f7,$24,$54,$86,$bc,$f5  ; 2
                .byte $31,$71,$b5,$fc,$48,$98,$ee,$48,$a9,$0d,$79,$ea  ; 3
                .byte $62,$e2,$6a,$f8,$90,$30,$dc,$90,$52,$1a,$f2,$d4  ; 4
                .byte $c4,$c4,$d4,$f0,$20,$60,$b8,$20,$a4,$34,$e4,$a8  ; 5
                .byte $88,$88,$a8,$e0,$40,$c0,$70,$40,$48,$68,$c8,$50  ; 6
                .byte $10,$10,$50,$c0,$80,$80,$e0,$80,$90,$d0,$90,$a0  ; 7
                .byte $20,$20,$a0,$80,$00,$00,$c0,$00,$20,$a0,$20,$40  ; 8
;-----------------------------------------

.bend



;===================== players of different qualities  =========================
;each player here has a jumptable/header with its code-locations used from outside
;(and each player has an own relocation-table (its location and size is in the player's header)
;the default player routine can be replaced by them on demand in the beginning (startup-menu)
;NUMBEROFPLAYERS=4 ;this value is not used but would be nice to have for later expansions

;player code-locations used by the editor:
;=========================================
;a.fix place at the beginning of the player, no need to give as player-header info:
;---------------------------------------------------------------------------------
;inisub playsub		;used by playadapter.inc
;mulpsub		;used by irq.inc

;b.fix place and in the editor they might even be zeropage-registers - no need to modify
;---------------------------------------------------------------------------------------
;ACTPTN,x			;used by displayer1.inc & keyhandler.inc
;SEQPOS,x TMPPOS,x SPDCNT,x PTNPOS,x		;used by playadapter.inc & keyhandler.inc
;ACTINS,x ACTIFX,x ACTFX2,x SLIDEVIB,x ACTNOT,x WFGHOST,x PTNGATE,x PWLOGHO,x 	;-||-

;c.subroutines with player-dependent addresses - a jumptable created for them just for editor-mode
;-------------------------------------------------------------------------------------------------
;SETSTUNE SEQSUB CHKNOTE CNTPLAY COMMONREGS(!pla!) ;
;PTNPLAY - in indirect way (playadapter.inc copies this code into the player)

;d.these memory-addresses should be treated correctly:
;----------------------------------------------------
;StrtPos+1 - solved by pointing from player to a byte with label 'StrtPos'
;ptncode, FSWITCH+1, FLTBAND+1 - solved by making a subruotine in player-jumptable to read/write these locations
;EXPTABH - need to modify editor (4 reads)

;e.addresses that player uses from the editor (no need to workaround, as players are compiled here together):
;-------------------------------------------------------------------------------------------------------------
;div7chn,x olstart,y CTFMETR+1 playmod wasjamm,x PWIHELP,x mutesolo,y


;============= player source files with different feature-sets (compilation settings) =======================

;-------------------------------------------------------------------------------
normalPlayer .block

.if (COMPILEDAPP==1)
description .text "The default player which features all   "
            .text "the necessities and almost every extra. "
#FeatInstances ;macro in settings.cfg - binary representation of the features (FeatInstance1 & FeatInstance2 arrays)
.fi

.if (COMPILEDAPP==2)
ATTACH_RELOCTABLE_ON=1 ;attach the relocation-table in exporter
.include "./player.asm" ;the './'... prefix is needed for 64tass before a certain version (rev274) to prevent compile-errors
.fi
;the default player source is included in editor.asm directly

.bend

;-------------------------------------------------------------------------------
mediumPlayer .block

PLAYERTYPE=1	;0=normal, 1=medium, 2=light, 3=extra

feature .block
TRANSPOSESUPP_ON=1 ;IF POSSIBLE TO TRANSPOSE WITH SEQ-FX
OCTAVESHIFT_ON=1 ;IF OCTAVE-SHIFTING IS ACCOUNTED FOR INSTRUMENTS OR NOT
CHORDSUPPORT_ON=1 ;CHORDS CALLABLE FROM ARP-TABLE OR NOT
CALCVIBRATO_ON=1  ;CALCULATED VIBRATO ON/OFF
VIBRATOTYPES_ON=0 ;WHETHER DIFFERENT VIBRATO-TYPES ARE SELECTABLE OR JUST THE DEFAULT 
DETUNESUPPORT_ON=1 ;DETUNE-COLUMN AUDIBLE OR NOT
PORTAVIBRA_ON=0 ;DROP BACK TO VIBRATO WHEN PORTAMENTO/LEGATO REACHED TARGET NOTE?
ARPSPEEDSUPP_ON=1 ;IF ARPEGGIO-SPEED IS ACCOUNTED OR NOT (FOR MULTISPEED)
GATEOFFPTR_ON=0 ;GATE-OFF WF/PW/FILTER-TABLEPOINTER SUPPORT ON/OF
FILTRESETSW_ON=1 ;ABILITY TO SWITCH FILTER-RESET OFF WHEN NOTE WITHOUT INSTRUMENT
FILTKBTRACK_ON=1 ;FILTER-CUTOFF-FREQUENCY KEYBOARD-TRACKING EFFECT ON/OFF
PWRESETSW_ON=1 ;ABILITY TO SWITCH PULSEWIDTH-TABLE RESET OFF WHEN NOTE WITHOUT INSTRUMENT 
PWKEYBTRACK_ON=0 ;PULSEWIDTH KEYBOARD-TRACKING EFFECT ON/OFF
HARDRESTYPES_ON=0 ;DIFFERENT HARDRESTART-ADSR/TIMER VALUES FOR EACH INSTRUMENT?
FRAME1SWITCH_ON=0 ;IF DISABLED, SEXY $09 HARDRESTART APPLIED FOR ALL INSTRUMENTS
TEMPOPRGSUPP_ON=1 ;TEMPO-PROGRAM AND FUNKTEMPO-CHANGING SUPPORT ON/OFF (PATTERN-FX)
FASTSPEEDBIND_ON=0 ;WHETHER TO CONNECT TICK0..2 IF SPEED IS LOWER (TO PRODUCE SOUND)
DELAYSUPPORT_ON=0 ;TRACK-DELAY AND NOTE-DELAY SUPPORT ON/OFF
SUBTUNEJUMP_ON=0 ;SUBTUNE-JUMPING SUPPORT ON/OFF
RETAINZEROPAGE_ON=0 ;SAVING/RESTORING ZEROPAGE BYTES BEFORE/AFTER PLAYER ROUTINE 
ALLGHOSTREGS_ON=0 ;USE GHOST-REGISTERS FOR ADSR & PULSEWIDTH TOO, WRITE ALL REGISTERS TO SID RAPIDLY AT END OF PLAYER (QUALITY)
FINEFILTSWEEP_ON=1 ;WHETHER 11BIT OR 8BIT FILTERSWEEP
FILT_CTRL_FX_ON=0 ;FILTER-SWITCHES AND RESONANCE ($D417) SETTING FX SUPPORT
FILTERALWAYS_ON=0 ;DON'T SKIP FILTER-PROGRAM (FOR 1-2 FRAMES) TO REDUCE RASTERTIME? - makes PULSEALWAYS_ON happen
PULSEALWAYS_ON=0 ;DON'T SKIP PULSE-PROGRAM (FOR 1-2 FRAMES) TO REDUCE RASTERTIME?
VIBSLIDEALWAYS_ON=0 ;DON'T SKIP VIBRATO/SLIDE/PORTAMENTO (FOR 1-2 FRAMES) TO REDUCE RASTERTIME? - overrides previous 2 settings
.bend

.if (COMPILEDAPP==1)
description .text "A moderately reduced player, It has got "
            .text "almost all function but less rastertime."
#FeatInstances ;macro in settings.cfg - binary representation of the features above (FeatInstance1 & FeatInstance2 arrays)
.else
ATTACH_RELOCTABLE_ON=1 ;attach the relocation-table in exporter
.fi

.include "././player.asm" ;the '././' prefix is needed for 64tass before a certain version to prevent compile-errors

.bend


;-------------------------------------------------------------------------------
lightPlayer .block

PLAYERTYPE=2	;0=normal, 1=medium, 2=light, 3=extra

feature .block
TRANSPOSESUPP_ON=0 ;IF POSSIBLE TO TRANSPOSE WITH SEQ-FX
OCTAVESHIFT_ON=0 ;IF OCTAVE-SHIFTING IS ACCOUNTED FOR INSTRUMENTS OR NOT
CHORDSUPPORT_ON=0 ;CHORDS CALLABLE FROM ARP-TABLE OR NOT
CALCVIBRATO_ON=0  ;CALCULATED VIBRATO ON/OFF
VIBRATOTYPES_ON=0 ;WHETHER DIFFERENT VIBRATO-TYPES ARE SELECTABLE OR JUST THE DEFAULT 
DETUNESUPPORT_ON=0 ;DETUNE-COLUMN AUDIBLE OR NOT
PORTAVIBRA_ON=0 ;DROP BACK TO VIBRATO WHEN PORTAMENTO/LEGATO REACHED TARGET NOTE?
ARPSPEEDSUPP_ON=0 ;IF ARPEGGIO-SPEED IS ACCOUNTED OR NOT (FOR MULTISPEED)
GATEOFFPTR_ON=0 ;GATE-OFF WF/PW/FILTER-TABLEPOINTER SUPPORT ON/OF
FILTRESETSW_ON=0 ;ABILITY TO SWITCH FILTER-RESET OFF WHEN NOTE WITHOUT INSTRUMENT
FILTKBTRACK_ON=0 ;FILTER-CUTOFF-FREQUENCY KEYBOARD-TRACKING EFFECT ON/OFF
PWRESETSW_ON=0 ;ABILITY TO SWITCH PULSEWIDTH-TABLE RESET OFF WHEN NOTE WITHOUT INSTRUMENT 
PWKEYBTRACK_ON=0 ;PULSEWIDTH KEYBOARD-TRACKING EFFECT ON/OFF
HARDRESTYPES_ON=0 ;DIFFERENT HARDRESTART-ADSR/TIMER VALUES FOR EACH INSTRUMENT?
FRAME1SWITCH_ON=0 ;IF DISABLED, SEXY $09 HARDRESTART APPLIED FOR ALL INSTRUMENTS
TEMPOPRGSUPP_ON=0 ;TEMPO-PROGRAM AND FUNKTEMPO-CHANGING SUPPORT ON/OFF (PATTERN-FX)
FASTSPEEDBIND_ON=0 ;WHETHER TO CONNECT TICK0..2 IF SPEED IS LOWER (TO PRODUCE SOUND)
DELAYSUPPORT_ON=0 ;TRACK-DELAY AND NOTE-DELAY SUPPORT ON/OFF
SUBTUNEJUMP_ON=0 ;SUBTUNE-JUMPING SUPPORT ON/OFF
RETAINZEROPAGE_ON=0 ;SAVING/RESTORING ZEROPAGE BYTES BEFORE/AFTER PLAYER ROUTINE 
ALLGHOSTREGS_ON=0 ;USE GHOST-REGISTERS FOR ADSR & PULSEWIDTH TOO, WRITE ALL REGISTERS TO SID RAPIDLY AT END OF PLAYER (QUALITY)
FINEFILTSWEEP_ON=0 ;WHETHER 11BIT OR 8BIT FILTERSWEEP
FILT_CTRL_FX_ON=0 ;FILTER-SWITCHES AND RESONANCE ($D417) SETTING FX SUPPORT
FILTERALWAYS_ON=0 ;DON'T SKIP FILTER-PROGRAM (FOR 1-2 FRAMES) TO REDUCE RASTERTIME? - makes PULSEALWAYS_ON happen
PULSEALWAYS_ON=0 ;DON'T SKIP PULSE-PROGRAM (FOR 1-2 FRAMES) TO REDUCE RASTERTIME?
VIBSLIDEALWAYS_ON=0 ;DON'T SKIP VIBRATO/SLIDE/PORTAMENTO (FOR 1-2 FRAMES) TO REDUCE RASTERTIME? - overrides previous 2 settings
.bend

.if (COMPILEDAPP==1)
description .text "A reduced player with small rastertime, "
            .text "all extra features are switched off...  "
#FeatInstances ;macro in settings.cfg - binary representation of the features above (FeatInstance1 & FeatInstance2 arrays)
.else
ATTACH_RELOCTABLE_ON=1 ;attach the relocation-table in exporter
.fi

.include "./././player.asm" ;the './././' prefix is needed for 64tass before a certain version to prevent compile-errors

.bend


;-------------------------------------------------------------------------------
extraPlayer .block 

PLAYERTYPE=3	;0=normal, 1=medium, 2=light, 3=extra

feature .block
TRANSPOSESUPP_ON=1 ;IF POSSIBLE TO TRANSPOSE WITH SEQ-FX
OCTAVESHIFT_ON=1 ;IF OCTAVE-SHIFTING IS ACCOUNTED FOR INSTRUMENTS OR NOT
CHORDSUPPORT_ON=1 ;CHORDS CALLABLE FROM ARP-TABLE OR NOT
CALCVIBRATO_ON=1  ;CALCULATED VIBRATO ON/OFF
VIBRATOTYPES_ON=1 ;WHETHER DIFFERENT VIBRATO-TYPES ARE SELECTABLE OR JUST THE DEFAULT 
DETUNESUPPORT_ON=1 ;DETUNE-COLUMN AUDIBLE OR NOT
PORTAVIBRA_ON=1 ;DROP BACK TO VIBRATO WHEN PORTAMENTO/LEGATO REACHED TARGET NOTE?
ARPSPEEDSUPP_ON=1 ;IF ARPEGGIO-SPEED IS ACCOUNTED OR NOT (FOR MULTISPEED)
GATEOFFPTR_ON=1 ;GATE-OFF WF/PW/FILTER-TABLEPOINTER SUPPORT ON/OF
FILTRESETSW_ON=1 ;ABILITY TO SWITCH FILTER-RESET OFF WHEN NOTE WITHOUT INSTRUMENT
FILTKBTRACK_ON=1 ;FILTER-CUTOFF-FREQUENCY KEYBOARD-TRACKING EFFECT ON/OFF
PWRESETSW_ON=1 ;ABILITY TO SWITCH PULSEWIDTH-TABLE RESET OFF WHEN NOTE WITHOUT INSTRUMENT 
PWKEYBTRACK_ON=1 ;PULSEWIDTH KEYBOARD-TRACKING EFFECT ON/OFF
HARDRESTYPES_ON=1 ;DIFFERENT HARDRESTART-ADSR/TIMER VALUES FOR EACH INSTRUMENT?
FRAME1SWITCH_ON=1 ;IF DISABLED, SEXY $09 HARDRESTART APPLIED FOR ALL INSTRUMENTS
TEMPOPRGSUPP_ON=1 ;TEMPO-PROGRAM AND FUNKTEMPO-CHANGING SUPPORT ON/OFF (PATTERN-FX)
FASTSPEEDBIND_ON=1 ;WHETHER TO CONNECT TICK0..2 IF SPEED IS LOWER (TO PRODUCE SOUND)
DELAYSUPPORT_ON=1 ;TRACK-DELAY AND NOTE-DELAY SUPPORT ON/OFF
SUBTUNEJUMP_ON=1 ;SUBTUNE-JUMPING SUPPORT ON/OFF
RETAINZEROPAGE_ON=1 ;SAVING/RESTORING ZEROPAGE BYTES BEFORE/AFTER PLAYER ROUTINE 
ALLGHOSTREGS_ON=1 ;USE GHOST-REGISTERS FOR ADSR & PULSEWIDTH TOO, WRITE ALL REGISTERS TO SID RAPIDLY AT END OF PLAYER (QUALITY)
FINEFILTSWEEP_ON=1 ;WHETHER 11BIT OR 8BIT FILTERSWEEP
FILT_CTRL_FX_ON=1 ;FILTER-SWITCHES AND RESONANCE ($D417) SETTING FX SUPPORT
FILTERALWAYS_ON=1 ;DON'T SKIP FILTER-PROGRAM (FOR 1-2 FRAMES) TO REDUCE RASTERTIME? - makes PULSEALWAYS_ON happen
PULSEALWAYS_ON=1 ;DON'T SKIP PULSE-PROGRAM (FOR 1-2 FRAMES) TO REDUCE RASTERTIME?
VIBSLIDEALWAYS_ON=1 ;DON'T SKIP VIBRATO/SLIDE/PORTAMENTO (FOR 1-2 FRAMES) TO REDUCE RASTERTIME? - overrides previous 2 settings
.bend

.if (COMPILEDAPP==1)
description .text "All extra features are switched on, and "
            .text "no matter what rastertime it takes...   "
#FeatInstances ;macro in settings.cfg - binary representation of the features above (FeatInstance1 & FeatInstance2 arrays)
.else
ATTACH_RELOCTABLE_ON=1 ;attach the relocation-table in exporter
.fi

.include "././././player.asm" ;the '././././' prefix is needed for 64tass before a certain version to prevent compile-errors

.bend


;=========================================================================================
