;ident:8,24
;******************************************************************************
;					 Hermit SID-WIZARD player routine
;******************************************************************************
; $Id: player.asm 182 2012-11-25 15:40:52Z hermitsoft $
;ATTENTION:ANY TIME YOU ADD AN ABSOLUTE-ADDRESSING COMMAND, REGISTER ITS ADDRESS IN THE TABLE AT THE END OF THIS FILE LIKE I DID.
;OTHERWISE THE RELOCATION WON'T BE APPLIED TO THAT COMMAND AND THE PLAYER CODE WON'T WORK AS EXPECTED

 ;PLAYERZP = $FE			;routine saves and restores the value of these 2 zeropage lacotions (so it can overlap)

;APPLICATION-RELATED TWEAKS FOR SHORTER EXECUTION TIME (RASTERTIME) AND SMALLER CODE-SIZE
;---------------------------------------------------------------------
		.if COMPILEDAPP=1;IF EDITOR IS BEING COMPILED
PACKEDNOPSUPP_ON = 0	;PACKED REST/NOP PLAYING IS NOT NEEDED IN TRACKER
ZEROPAGESAVE_ON = 0		;NOT NEEDED IN EDITOR - SAVING/RESTORING ZEROPAGE BYTES BEFORE/AFTER PLAYER ROUTINE
		.else
PACKEDNOPSUPP_ON = 1	;IF PACKED REST/NOP PLAYING IS SUPPORTED
ZEROPAGESAVE_ON = feature.RETAINZEROPAGE_ON ;IF ZEROPAGE-SAVING IS DISABLED GLOBALLY
		.fi

playercode			;copiers will know where it starts
.logical PLAYERADDR	;set logical compilation address 

;================================JUMPTABLE=====================================
PLAYER_JUMPTABLE
inisub	jmp INITER		;PLAYER & SID INIT ROUTINE
playsub jmp PLAYER		;PLEYER ROUTINE ITSELF
mulpsub jmp MULPLY		;MULTISPEED CALL
volusub jmp SMALFXA		;VOLUME-SETTING CALL

;-------player-header- jumptable&addresses to grab different player-types ------
;memory-positions are given as absolute-addresses for faster processing, players are always at $1000
.if COMPILEDAPP==1
playerheader ;'indirect' jumps (real indirect jumps not good as we're calling by 'jsr' from editor)
PLAYER_TYPE .byte PLAYERTYPE ;current player/driver type (normal=0/medium=1/light=2/extra=3) 
iSETSTU	jmp SETSTUNE
iSEQSUB	jmp SEQSUB
iCHKNOT	jmp CHKNOTE
iCNTPLY	jmp CNTPLAY
iCOMMRE	jmp COMMONREGS	;!be careful not to have zeropage-saving turned on for the editor! (would cause 2 pla at the end of COMMONREGS)
iPTNPLY	jmp PTNPLAY
StrtPos .byte 0 ;set to nonzero by editor if playing from position with F2
wPtncod	sta ptncode,x
		rts
rFSWITC	lda FSWITCH+1
		rts
rFLTBND lda FLTBAND+1
		rts
aEXPTBH	.word EXPTABH
.else
FRAME_SPD .byte 1 ;saved by exporter from tune-header, used by EXE/SID exports
TrackerID .text " SID-WIZARD ",SWversion," " ;containing this string will be easier to recognize the used editor in releases
.fi

PLAYER_JUMPTABLE_END
;==============================================================================
.if PLAYERZP_VAR  ;BEGINNING OF VARIABLES' SECTION - VARIABLES ARRANGED IN BUNCHES OF 7
 VARIABLES = PLAYERZP_VAR	;using zeropage-variables for player
.else
 VARIABLES = PLAYER_JUMPTABLE_END
.fi

varsect1=VARIABLES
FREQLO   = varsect1+0	;(SID.0) FREQUENCY (PITCH) LO-BYTE GHOST-REGISTERS
FREQHI   = varsect1+1	;(SID.1) FREQUENCY (PITCH) PITCH HI-BYTE GHOST-REGISTERS
PWLOGHO  = varsect1+2	;(SID.2) PULSEWIDTH LOW-BITE GHOST-REGISTERS
PWHIGHO  = varsect1+3	;(SID.3) PULSEWIDTH HI-BYTE GHOST-REGISTERS
WFGHOST  = varsect1+4	;(SID.4) WAVEFORM/CTRL GHOST-REGISTERS
PTNGATE  = varsect1+5	;GATE OFF/ON STATUS CONTROLLED BY PATTERN (AND MUTE/SOLO IN EDITOR?)
PWEEPCNT = varsect1+6	;PULSEWIDTH SWEEP-LENGTH TIMER

varsect2=varsect1+3*7
PACKCNT = varsect2+0	;PACKED NOP/REST ($70..$77) COUNTER
SPDCNT  = varsect2+1	;FRAMESPEED COUNTERS (INCREMENTAL)
SEQPOS  = varsect2+2	;ORDERLIST SEQUENCE PLAYPOSITION-SHOULDN'T BE ON PAGE-BOUNDARY!
PTNPOS  = varsect2+3	;PATTERN PLAY-POSITION (IN MEMORY)
WFTPOS	= varsect2+4	;WF-ARP TABLE POSITION-INDEX
PWTPOS	= varsect2+5	;PW-TABLE POSITION-INDEX
ARPSCNT = varsect2+6	;ARPEGGIO-SPEED COUNTERS; also used as multispeed 1st frame detector for multispeed

varsect3=varsect2+3*7
ACTPTN	= varsect3+0	;CURRENT PATTERN
ACTNOT	= varsect3+1	;ACTUAL NOTES/GATEOFF ON TRACK 0..2 (+FX0, VIB,RING)
DPITCH	= varsect3+2	;ACTUAL DISCRETE NOTE-PITCH (ISN'T AFFECTED BY EFFECTS)
ACTIFX	= varsect3+3	;ACTUAL INSTR/ONESHOT-FX ON TRACK 0..2
ACTINS	= varsect3+4	;ACTUAL (SELECTED) INSTRUMENT - NOT OVERWRITTEN BY FX/LEGATO
ACTFX2	= varsect3+5	;ACTUAL FX2-NUMBERS ON TRACK 0..2
ACTVAL	= varsect3+6	;ACTUAL FX2-VALUES ON TRACK 0..2

varsect4=varsect3+3*7
SLIDEVIB = varsect4+0	;SLIDEUP/SLIDEDOWN/PORTAMENTO/VIBRATO-TYPE (EXTRACTED FROM BIT 4..5 OF INSTRUMENT-CONTROL BYTE)
FREQMODL = varsect4+1	;FREQUENCY-SLIDE (MODIFICATION) LOW BYTE (SET BY INSTRUMENT/PATTERN-FX)
FREQMODH = varsect4+2	;FREQUENCY-SLIDE (MODIFICATION) HIGH-BYTE (SET BY INSTRUMENT/PATTERN-FX)
VIDELCNT = varsect4+3	;VIBRATO-DELAY COUNTER (SET BY INSTRUMENT)
VIBFREQU = varsect4+4	;VIBRATO-FREQUENCIES (SET BY INSTRUMENT/PATTERN-FX)
VIBRACNT = varsect4+5	;VIBRATO COUNTERS (FOR VIBRATO FREQUENCY HANDLING)
TRANSP	= varsect4+6	;TRANSPOSE-AMOUNT ON TRACKS (SET BY SEQUENCE-FX)

;upcoming variable-bunches can be stripped out in some player-types if the corresponding features are switched off
varsect5=varsect4+3*7
.if (feature.TEMPOPRGSUPP_ON || feature.ARPSPEEDSUPP_ON || feature.PWKEYBTRACK_ON || feature.CHORDSUPPORT_ON)
TMPPTR  = varsect5+0	;STARTPOINTS OF ACTUAL TEMPOPROGRAMS ;USED BY OTHER PARTS
TMPPOS  = varsect5+1	;ACTUAL TEMPO-POSITIONS IN TEMPOTBL (NEEDED BY PLAYADAPTER IN EDITOR TOO)
ARPSPED = varsect5+2	;ARPEGGIO-SPEED (SET BY INSTRUMENT OR PATTERN-FX)
PKBDTRK = varsect5+3	;PULSEWIDTH KEYBOARD-TRACK VALUE
ACTCHORD = varsect5+4	;ACTUAL CHORDS ON TRACKS (INSTRUMENT/PATT.FX SELECTS IT)
CHORDPOS = varsect5+5	;PLAYED POSITION (INDEX) OF ACTUAL CHORD IN CHORDTABLE
;??? something new can be put here
varsect6=varsect5+3*7
.else
varsect6=varsect5		;in 'light' version it probably happens
.fi

.if feature.ALLGHOSTREGS_ON
SID0GHO	= varsect6+0	;SID'S FREQUENCY-LO GHOST-REGISTER
SID1GHO = varsect6+1	;SID'S FREQUENCY-HI GHOST-REGISTER
SID2GHO	= varsect6+2	;SID'S PULSEWIDTH-LO GHOST-REGISTER
SID3GHO	= varsect6+3	;SID'S PULSEWIDTH-HI GHOST-REGISTER
SID4GHO = varsect6+4	;SID'S WAVEFORM/CONTROL GHOST-REGISTER
ADGHOST	= varsect6+5	;SID'S ATTACK/DECAY GHOST-REGISTER
SRGHOST	= varsect6+6	;SID'S SUSTAIN/RELEASE GHOST-REGISTER
ENDVARIABLES=varsect6+3*7
.else
ENDVARIABLES=varsect6	;it probably happens in versions other than 'extra'
.fi



;==========ALLOCATE MEMORY FOR VARIABLES or PLAYER SIGNATURE & VERSION==========
.if (COMPILEDAPP==1)
 .if (PLAYERZP_VAR==0)
  .fill (ENDVARIABLES-VARIABLES)
 .fi
.else ;in the editor software-info was not needed
 TRACKERINFO=PLAYER_JUMPTABLE_END ;if variables are there, overwriting zeroes, but initer routine will zero them again
 TUNE_HEADER=PLAYER_JUMPTABLE+$20  ;TUNE-HEADER WILL BE COPIED HERE BY EXPORTER. ;align to be better seen in monitor/debugger
 .fill (ENDVARIABLES-VARIABLES)-(*-TRACKERINFO) ;padding space if variables take less memory (when zeropage is used for them)
.fi

;------------------------------------------------------------------------------
CONST_VAR				;CONSTANT VALUES AND MISC.VARIABLES NOT INITED BY INIT-ROUTINE
FLSWTBL .byte 1			;.... CONSTANTS-BITMASK FOR SID-FILTERSWITCHES
FLSWTB2 .byte $FE		;FILTERSWITCH 'AND' TABLE (CONSTANTS)
TRKTMPOS .byte 2		;TRACK-TEMPO-POSITION TABLE (CONSTANTNS)
TRDELAY .byte 0			;TRACK-DELAY AMOUNTS
SEQTEMPO .byte 0		;SEQ-FX TEMPOCHANGE DELAYER
TRANSP2 .byte 0			;DELAYED TRANSPOSE-VALUE (BECAUSE SEQ-FX DOES IT EARLY)
DETUNER	.byte 0			;detuning value on the tracks (affected by wf-arp-detune inst.table or patt.FX)
		.cwarn *>7+CONST_VAR,"MAXIMUM 7 VARIABLES/CONSTANTS ALLOWED PER BUNCH!"
		.byte 2,$FD,4,0,0,0,0, 4,$FB,6,0,0,0,0 ;ENSURE SPACE FOR THE BUNCH OF CONSTANTS/VARIABLES ON ALL THE 3 CHANNELS
CONST_VAR_END

;******************************************************************************
INITER					;INITIALIZE SUBTUNE (INPUT: SUBTUNE-NUMBER IN ACCU.)
a1		jsr SETSTUNE	;SET SUBTUNE GIVEN IN ACCU (ADDR,SPD)
INIPVAR ldy #(ENDVARIABLES-VARIABLES)-1
loop1	lda #0			;ZERO ALL COUNTERS & POINTERS & ROWDATA, ETC.		;lda #8 ;WRITING TEST-BITS TO SID PREVENTS SOUND-POP AT INIT?
		sta SIDBASE,y	;INIT SID (X CAN BE OVER $20 ON A STOCK C64)
a2		sta VARIABLES,y
		dey
		bpl loop1		;ACCU MUST BE 0 WHEN THIS LOOP ENDS
a3		sta FLTBAND+1	;RESET FILTER-BAND REGISTER BITS
a68		sta FLSHIFT+1	;RESET FILTER-SHIFTING EFFECT
		.if feature.FILTKBTRACK_ON
a1b		sta CKBDTRK+1	;INIT FILTER-KEYBOARD TRACK, AS NOT NEEDED IF NO FILTER USED
		.fi
		.if feature.FILT_CTRL_FX_ON
a109b	sta FSWITCH+1	;initialize filter-switches, especially filt-external switch
		.fi
INITVOL lda #15			;MAX. VOLUME VALUE
a4		sta MAINVOL+1
a73		sta SEQVOLU+1
a5		sta FLTCTRL+1	;NOT IN 0..2 RANGE - NO FILTER FOR ANY CHANNEL ON INIT

INITPTN ldx #2*7
loop2
		lda #0
		.if feature.TRANSPOSESUPP_ON
a21		sta TRANSP2,x
		.fi
a22		sta SEQTEMPO,x

SEQFXLO ldy SEQPOS,x	;IT'S 0 AT THE BEGINNING FOR ALL TRACKS
a7		jsr SEQSUB		;GET PATTERNS AT 1ST POSITIONS OF SEQUENCES
		.if COMPILEDAPP=1
		beq TestPos	;if zero pattern-number somehow, don't set it
		bmi chSeqFx ;...check above $80
		cmp #maxptnamount+1
		bcc INIPTN		;if not legal pattern, don't set
		bcs TestPos	;jump
		.else
		bpl INIPTN		;IF 1ST POSITION IS NOT PATTERN, LEAVE IT OR PERFORM SEQ-FX
		.fi
chSeqFx	cmp #$FE		;IF DELIMITER AT 1ST POSITION, DON'T SET PATTERN
		bcs endseqset	;IF LOWER THAN $FE, PERFORM ORDERLIST-EFFECTS
a6		jsr SEQ_FX		;HANDLE ORDERLIST/SEQUENCE-FX, INPUT:A, DOESN'T DISTURB X&Y
a237	inc SEQPOS,x	;GO TO NEXT SEQUENCE-POSITION
		bne SEQFXLO		;AVOID ENDLESS LOOP
INIPTN	sta ACTPTN,x	;SET PATTERNS
		.if COMPILEDAPP=1
TestPos	lda StrtPos		;is set to nonzero by editor if playing from position with F2
		beq endseqset	;if F2-key initiated the start
		lda playadapter.div7chn,x	;convert (divide) 0..7..14 to 0..1..2
		tay
		lda playadapter.olstart,y
		cmp SEQPOS,x
        beq endseqset
		bcs a237
		.fi
endseqset
		.if feature.DELAYSUPPORT_ON
		lda #$FF
a2b		sta TRDELAY,x	;PREPARE POSSIBLE UPCOMING TRACK-DELAY
		.fi
		txa
		sec
		sbc #7			;CYCLE SID-CHANNELS
		tax
		bpl loop2
		rts


;******************************************************************************
PLAYER
		.if ZEROPAGESAVE_ON
		.if (PLAYERZP_VAR==0) ;no point to save zeropage if it's used for variables
		lda PLAYERZP+0	;STORE ZEROPAGE  ;SINGLE-SPEED PLAYING
		pha
		lda PLAYERZP+1
		pha
		.fi
		.fi
CHANCNT ldx #2*7		;CHANNEL 1
a8		jsr DOTRACK
		ldx #1*7		;CHANNEL 2
a9		jsr DOTRACK
		ldx #0*7		;CHANNEL 3
a10		jsr DOTRACK

COMMONREGS				;CALCULATING AND WRITING COMMON SID REGISTERS - ENTRY POINT FOR EDITOR

		.if feature.ALLGHOSTREGS_ON  ;IF GHOST-REGISTERS ARE USED FOR EVERY SID-REGISTERS (EXTRA) - takes 3-4 more rasterlines
		ldx #2*7
loop3	
a125b	lda SRGHOST,x	;important to keep some distance between SR and Waveform-setting for more reliable notestart!!!!!
		sta SIDBASE+6,x
a126b	lda ADGHOST,x	;important to keep some distance between AD and Waveform-setting for more reliable notestart!!!!!
		sta SIDBASE+5,x
a119b	lda SID0GHO,x
		sta SIDBASE+0,x
a127b	lda SID1GHO,x
		sta SIDBASE+1,x
a128b	lda SID2GHO,x
		sta SIDBASE+2,x
a129b	lda SID3GHO,x
		sta SIDBASE+3,x
a130b	lda SID4GHO,x   ;keep distance from ADSR setting for more reliable notestart!!!
		sta SIDBASE+4,x
		txa
		sec
		sbc #7
		tax
		bpl loop3
		.fi

FSWITCH lda #$00  ;$08	;SELF-WRITTEN - TRACKS' FITER-SWITCHES' NIBBLE (EXTERNAL FILTER ON/OFF,BigFx-$1F - REDUCE SID-noise )
RESONIB ora #0			;SELF-WRITTEN - RESONANCE-NIBBLE OF FILTER (UPPER 4 BITS)
		sta SIDBASE+$17
MAINVOL lda #$0F		;SELF-WRITTEN CODE - MAIN VOLUME NIBBLE OF $D418
FLTBAND ora #0			;SELF-WRITTEN, FILTERBAND-GHOSTREGS MUST BE HERE (ON HI-NIBBLE)
		sta SIDBASE+$18
		clc				;PRE-SET CARRY FOR ADDITIONS
		.if feature.FILTKBTRACK_ON
CKBDTRK lda #0			;SELF-WRITTEN - KEYBOARD-TRACK EFFECT AMOUNT (MULTIPLY/DIVIDE) IF 0, NO EFFECT
		beq CTFHGHO		;IF 0, NO KEYBOARD-TRACKING
a3b		ldx FLTCTRL+1	;X = ACTUAL FILTER-CONTROLLER TRACK
a4b		adc DPITCH,x	;ACTUAL FILTER-CONTROLLER TRACK'S NOTE-NUMBER ;THE ADDITION (OR SUBSTRACTION IF A>$80)
		tay
a5b		lda EXPTABH,y	;USE EXPONENT TABLE AS QUASY MULTIPLY/DIVIDE FUNCTION BASED ON CKBDTRK
CTFHGHO adc #0			;SELF-WRITTEN - HIGH BYTE OF FILTER CUTOFF-FREQUENCY
		.else
CTFHGHO lda #0			;SELF-WRITTEN - HIGH BYTE OF FILTER CUTOFF-FREQUENCY
		.fi
FLSHIFT adc #0			;PATTERN-FX INITIATED FILTER-SHIFTING
		sta SIDBASE+$16
		.if COMPILEDAPP=1
		sta CTFMETR+1	;EASE CUTOFF-METER DISPLAY FOR EDITOR
		.fi
		.if feature.FINEFILTSWEEP_ON
CTFLGHO lda #0			;SELF-WRITTEN - LOW NIBBLE OF FILTER CUTOFF-FREQUENCY
		sta SIDBASE+$15 ;FOR RASTERTIME REASONS LOW-BITS OF CUTOFF IS NOT KEYBOARD-TRACKED
		.fi
		
RETPLAY					;RETURN FROM PLAYER
		.if ZEROPAGESAVE_ON
		.if (PLAYERZP_VAR==0) ;no point to save zeropage if it's used for variables
		pla				;RESTORE ZEROPAGE
		sta PLAYERZP+1
		pla
		sta PLAYERZP+0
		.fi
		.fi
retsubr	rts


;******************************************************************************
MULPLY					;MULTISPEED-PLAYING ROUTINE
		.if ZEROPAGESAVE_ON
		.if (PLAYERZP_VAR==0) ;no point to save zeropage if it's used for variables
		lda PLAYERZP+0	;STORE ZEROPAGE  ;SINGLE-SPEED PLAYING
		pha
		lda PLAYERZP+1
		pha
		.fi
		.fi
		ldx #2*7		;CHANNEL 1
a11		jsr MULCNTP		;PLAY INSTRUMENT-TABLE(S)
		ldx #1*7		;CHANNEL 2
a12		jsr MULCNTP		;PLAY INSTRUMENT-TABLE(S)
		ldx #0*7		;CHANNEL 3
a13		jsr MULCNTP		;PLAY INSTRUMENT-TABLE(S)
a14		jmp COMMONREGS	;PLAY FILTER TOO ;JMP RETPLAY	;RESTURN FROM MULTISPEED-PLAYER PART
;--------------------
MULCNTP	.if COMPILEDAPP=1
		lda playadapter.playmod
		ora playadapter.wasjamm,x ;if no jammed note yet, don't play multispeed either
		beq retsubr
		.fi
		;don't allow multispeed to destruct 1st frame waveform-setting
a236	lda ARPSCNT,x	;ARPSCNT also used as multispeed 1st frame detector
		bmi retsubr		;if still $FF  (reset on frame1 to $FF and only set to arp-speed in next frame)
a228	ldy ACTINS,x	;PUT CURRENT INSTRUMENT'S BASE-ADDRESS TO ZEROPAGE-POINTERS
p_insl1 lda INSPTLO,y	;Y IS NUMBER OF CURRENT INSTRUMENT
		sta PLAYERZP+0
p_insh1 lda INSPTHI,y
		sta PLAYERZP+1
		ldy #7			;CHECK ARPSPEED DATA OF ACTUAL INSTRUMENT (BIT 6 & 7)
		lda (PLAYERZP),y
		bmi MULTIFI		;IF INSTRUMENT-ARPEGGIO SPEED IS BIGGER THAN $80 (BIT7=1), MULTISPEED FILTER TOO
		and #$40		;IF BIT6=1, PULSEWIDTH IS MULTISPEED TOO
		bne MULTIPW		;IF SPEED BIT6=1
a15		jmp WFARPTB		;MULTISPEED SUPPORT ONLY FOR WAVEFORM-TABLE
MULTIPW jmp SETPWID		;MULTISPEED SUPPORT FOR PULSEWIDTH-TABLE TOO
MULTIFI jmp FLTCTRL		;MULTISPEED SUPPORT FOR PULSEWIDTH-TABLE AND FILTERTABLE TOO


;******************************************************************************
DOTRACK
		.if feature.TEMPOPRGSUPP_ON
a6b		ldy TMPPOS,x	;HANDLE TEMPO (SUBTUNE-TEMPO/FUNKTEMPO/TEMPO-PROGRAM)
		.fi
a16		lda SPDCNT,x
		.if feature.TEMPOPRGSUPP_ON
		iny				;PREPARE Y FOR ADVANCE IN TEMPOTABLE
		.fi
		sec
		;tempoprogram-table base-address to adjust in SID-maker
		.if feature.TEMPOPRGSUPP_ON
p_tmpt1 sbc TEMPOTBL-1,y;COMPARE SPEED-COUNTER TO ACTUAL TEMPO, AND CHECK BIT 7
		.else
p_tmpt1 sbc TEMPOTBL+0	;SINGLETEMPO
		.fi
		beq a17			;IF EQUAL, GO TO ADVANCE IN TEMPO-PROGRAM
		bvc a18			;CHECK FOR $80 RESULT TOO. IF NOT MATCH, GO TO REST OF TICKS
		.if feature.TEMPOPRGSUPP_ON
a9b		ldy TMPPTR,x	;SPDCNT=TEMPO-80, GET ACTUAL TEMPO-PROGRAM'S POSITION
		.fi
		lda #0			;HERE WE SET ACCU (TEMPOCOUNTER) TO 0 TO GET NEXT ROW
a17		sta SPDCNT,x	;ZERO SPEEDCOUNTER,INCREMENTED SOON TO 1 (IN THIS FRAME)
		.if feature.TEMPOPRGSUPP_ON
		tya				;Y HERE IS EQUAL TO THE TEMPOTABLE POINTER WE WOULD SET
a10b	sta TMPPOS,x	;THEN RETURN BACK TO START OF TEMPOPROGRAM (SET TEMPOCNT)
		.fi
a18		lda SPDCNT,x	;CHECK SPECIAL TICKS (SPDCNT IS IN 0..TEMPO RANGE)
a19		inc SPDCNT,x	;INC SPEEDCOUNTERS TO STEP FORWARD 1 TICK
TICKSEL cmp #0
		beq TICK_0		;CHECK FOR TICK 0 (BRANCH IF SPDCNT = 0 )
a20		jmp CHKTCK1		;CHECK IF TICK1


;------------------------------------------------------------
TICK_0	ldy ACTPTN,x	;PUT CURRENT PATTERN'S ADDRESS TO ZEROPAGE-POINTERS
p_ptnl1 lda PPTRLO,y	;Y IS NUMBER OF CURRENT PATTERN
		sta PLAYERZP+0
p_ptnh1 lda PPTRHI,y
		sta PLAYERZP+1
READROW lda #0
a23		sta ACTIFX,x	;ENSURE ONE-SHOT INSTRUMENT-SELECTION/SMALL-FX
a24		sta ACTFX2,x	;ENSURE ONE-SHOT SMALL-/BIG-FX
SEQVOLU lda #$0F		;SELF-WRITTEN - USED TO DELAY SETTING OF MAIN-VOLUME SEQ.FX
a74		sta MAINVOL+1
		.if feature.TEMPOPRGSUPP_ON
a61b	lda SEQTEMPO,x	;PERFORM TRACK-TEMPO SEQ.FX (DELAYED)
		beq endseqtmp
a62b	jsr TRAKTMP		;SET TRACK-TEMPO
		lda #0
a106b	sta SEQTEMPO,x
endseqtmp
		.fi

a25		ldy PTNPOS,x	;READ CONTENT OF ACTUAL PATTERN-ROW-----------
		.if PACKEDNOPSUPP_ON;NOT RECOMMENDED TO SWITCH OFF SUPPORT, UNLESS YOU DON'T EVER WANT IT
a11b	lda PACKCNT,x	;HANDLE PACKED NOP (DECREMENT PACK-COUNTER AND SKIP READING)
		bne PACKNOP		;IF PACKED NOP COUNTER IS NONZERO, DECREASE IT.
		.fi
CHNOTEC lda (PLAYERZP),y;READ ACTUAL NOTE FROM NOTE-COLUMN
		.if PACKEDNOPSUPP_ON;NOT RECOMMENDED TO SWITCH OFF SUPPORT, UNLESS YOU DON'T EVER WANT IT
		cmp #PACKEDMIN	;CHECK PACKED NOP, STORE 0 IN ACTNOT,X FOR IT AND SET PACK-COUNTER!
		bcc NOPACKR		;IF A < PACKEDMIN
		cmp #PACKEDMAX+1
		bcs NOPACKR		;IF A > PACKEDMAX
		;sec				;A IS IN PACKED NOP RANGE
		sbc #PACKEDMIN-2-1;CHANGE RANGE $70..$77 TO $1..$8, additional -1 because of C=0
a12b	sta PACKCNT,x	;store repeater amount in X
PACKNOP dec PACKCNT,x
		lda #$00		;PUT 'NOP' INTO ACCU IF PACKED REST IS EXECUTED
NOPACKR cmp #0			;RE-TEST ACCU BIT 7
		.fi				;END OF CHECKING PACKED NOP SUPPORT
		bmi gocolu2		;IF NOTE ABOVE $80 GO TO CHECK NEXT COLUMN
a26		sta ACTNOT,x
		bpl SETPPOS		;IF NOTE BELOW $80, END OF ROW
gocolu2	and #$7F		;ELIMINATE BIT7
a28		sta ACTNOT,x
		iny				;CHECK FOR INST-SELECTION/SMALL-FX
CHINSTC lda (PLAYERZP),y;READ ACTUAL INST/SMALL-FX
		bmi gocolu3		;IF INST/FX BELOW $80, END OF ROW
a29		sta ACTIFX,x	;LATER SEPARATE INSTRUMENT ($1..$3F) FROM SMALL-FX ($3F..$7F)
		bpl SETPPOS

gocolu3	and #$7F		;ELIMINATE BIT7
a31		sta ACTIFX,x
		iny				;CHECK FOR BIG-FX
CHFXCOL lda (PLAYERZP),y;READ ACTUAL SMALL-/BIGFX
a32		sta ACTFX2,x
		and #$E0
		bne SETPPOS		;IF ABOVE $1F (SMALLFX), END OF ROW
		iny				;BIG-FX BRANCH
CHFXVAL lda (PLAYERZP),y;READ ACTUAL EFX-VALUE (BIG-FX)
a33		sta ACTVAL,x
SETPPOS tya
a34		sta PTNPOS,x
		.if feature.FASTSPEEDBIND_ON
CHKTMP1 ldy TMPPOS,x	;CHECK IF TEMPO IS NOT BIGGER THAN 1
p_tmpt2 lda TEMPOTBL,y
		and #$7F
		cmp #2
		bpl +
a204b	jmp PTN_SEQ		;IF TEMPO IS NOT BIGGER THAN 1, DON'T DO HR2 BUT HANDLE PATTERN & SEQUENCE
		+
		.fi
		.if feature.HARDRESTYPES_ON
		lda #2			;SIGN TICK2 TO HARDRESTART-ROUTINE
		.fi
HARDRST ldy ACTNOT,x	;CHECK FOR 2 FRAME LONG HARD-RESTART ;CHECK IF NOTE COMES AT ALL
		beq NONEWNO		;IF NO NEW NOTE STARTING, NO HARD-RESTART PERFORMED
		cpy #$60		;CHECK IF NOTE-FX (BIGGER THAN $60)
		bcc NEWNOTE		;IF NOTE-FX, DON-T PERFORM HARDRESTART
NONEWNO jmp CNTPLAY		;NO NEED TO PREPARE NEXT NOTE HERE, SIMPLY PLAY ACTUAL NOTE

NEWNOTE ldy ACTFX2,x	;ACTUAL BIG EFFECT
		cpy #$03		;CHECK IF PORTAMENTO BIG-FX IS BEING EXECUTED
		beq NONEWNO
a224	ldy SLIDEVIB,x  ;was there portamento note-FX? ($FF)
		iny 
		beq NONEWNO
a219	ldy ACTIFX,x	;THERE IS A MUSICAL NOTE, EXAMINE INSTRUMENT-COLUMN
		.if feature.HARDRESTYPES_ON
		beq a13b		;IF NOP ($00), GO TO USE PREVIOUSLY SELECTED INSTRUMENT FOR HARD RESTART
		.fi
		cpy #$3F		;HARDWIRED VALUE OF LEGATO, CARRY BIT AFFECTED
		beq NONEWNO		;IF LEGATO, NO HARD-RESTART PERFORMED
		.if feature.HARDRESTYPES_ON
		bmi wasinst		;IF INSTRUMENT SELECTION (SMALLER THAN $3F)
a13b	ldy ACTINS,x	;IF NOP OR INST.FX, USE PREVIOUSLY SELECTED INSTRUMENT
wasinst	pha				;STORE HR-TICK-TIMER-NUMBER
p_insl2 lda INSPTLO,y	;Y IS NUMBER OF CURRENT INSTRUMENT
		sta PLAYERZP+0
p_insh2 lda INSPTHI,y
		sta PLAYERZP+1
		pla				;RESTORE HR-TICK-TIMER-NUMBER
ISHARDR ldy #0			;GET CONTROL BYTE OF UPCOMING INSTRUMENT
		and (PLAYERZP),y;EXTRACT 2 FRAME HARD-RESTART SWITCH-BIT
		beq HRENDER		;BRANCH IF 2 FRAME LONG HARDRESTART, ELSE DON'T PERFORM HR YET, BUT SKIP PW/FILT
		.fi
HRGTOFF	lda #$FE
a221	sta PTNGATE,x	;WF-ARP TABLE MUTING
a222	and WFGHOST,x
a223	sta WFGHOST,x
		.if feature.HARDRESTYPES_ON
		 iny				;Y=1
		 lda (PLAYERZP),y;GET HR-AD
		 .if feature.ALLGHOSTREGS_ON==0
		 sta SIDBASE+5,x
		 .else
a110b	 sta ADGHOST,x
		 .fi
		 iny				;Y=2
		 lda (PLAYERZP),y;GET HR-SR
		 .if feature.ALLGHOSTREGS_ON==0
		 sta SIDBASE+6,x
		 .else
a111b	 sta SRGHOST,x
		 .fi
		 ldy #0
		 lda (PLAYERZP),y;Y=0 HERE
		 and #4			;EXTRACT GATE-OFF HARD-RESTART SWITCH
		 beq HRENDER ;Attack=0,Decay=0 for staccato playing
		 lda #$18 ;mute the sound strongly with TEST-bit, but keep oscillator
a14b	 sta WFGHOST,x
		 .if feature.ALLGHOSTREGS_ON==0
		 sta SIDBASE+4,x
		 .else
a120b	 sta SID4GHO,x
		 .fi
		 rts
		.else			;IF ONLY DEFAULT HARDRESTARTVALUE SELECTED
		 lda #>DEFAULTHRADSR;$0F?
		 .if feature.ALLGHOSTREGS_ON==0
		 sta SIDBASE+5,x
		 .else
a110b	 sta ADGHOST,x
		 .fi
		 lda #<DEFAULTHRADSR;$F0?
		 .if feature.ALLGHOSTREGS_ON==0		
		 sta SIDBASE+6,x
		 .else
a111b	 sta SRGHOST,x		
		 .fi
		.fi				;END OF CHECKING IF HARDRESTART-TYPE AND HR-ADSR IS THE SAME FOR ALL INSTRUMENTS
HRENDER	;end of hard-restart
a229	ldy ACTINS,x	;PUT CURRENT INSTRUMENT'S BASE-ADDRESS TO ZEROPAGE-POINTERS
p_insl3 lda INSPTLO,y	;Y IS NUMBER OF CURRENT INSTRUMENT
		sta PLAYERZP+0
p_insh3 lda INSPTHI,y
		sta PLAYERZP+1 ;this value shouldn't be 0 anytime
		.if feature.VIBSLIDEALWAYS_ON ;if still want slide/vibrato to go, but no point for that
a15b	jmp CNTPLY2
		.elsif feature.FILTERALWAYS_ON
a15b	jmp FLTCTRL
		.elsif feature.PULSEALWAYS_ON
a15b	jmp SETPWID
		.else
a15b	jmp WFARPTB		;CNTPLAY2 ;SKIP PULSEWIDTH-FILTER-TABLES AND VIBRATO IF NEW NOTE COMES BUT NO HR
		.fi

;-----------------------------------------------------------
CHKTCK1 cmp #2
		bpl CHKTCK2		;CHECK FOR TICK 1 (BRANCH IF SPDCNT>1)
TICK_1	ldy ACTPTN,x	;PUT CURRENT PATTERN'S BASE-ADDRESS TO ZEROPAGE-POINTERS
p_ptnl2 lda PPTRLO,y	;Y IS NUMBER OF CURRENT PATTERN
		sta PLAYERZP+0
p_ptnh2 lda PPTRHI,y
		sta PLAYERZP+1
PTN_SEQ ldy PTNPOS,x	;FETCH PATTERN-POSITION TO Y
		.if feature.TRANSPOSESUPP_ON
a104b	lda TRANSP2,x	;PERFORM TRANSPOSE-SEQ.FX
a105b	sta TRANSP,x	;DELAYER TO COMPENSATE EARLY SEQ.FX
		.fi

		.if PACKEDNOPSUPP_ON;NOT RECOMMENDED TO SWITCH OFF SUPPORT, UNLESS YOU DON'T EVER WANT IT
a19b	lda PACKCNT,x	;HANDLE PACKED NOP (IF COUNTING, DON'T ICREMENT PTNPOS,X)
		bne SETPPO2		;IF PACKED NOP COUNTER IS NONZERO, STAY IN PLACE
		.fi
		iny
		lda (PLAYERZP),y;READ NEXT ROW 1ST BYTE, TO CHECK PATTERN-END
		cmp #$FF		;HARDWIRED PTTERN-DELIMITER (PATTERN-END)
		bne SETPPO2		;IF NOT END OF PATTERN, JUST STORE PTNCNT
ptncode .byte $BC, <SEQPOS, >SEQPOS ;ldy SEQPOS,x	;editor manipulates this opcode & operand to accomplish pattern-playing (JMP PTNPLAY)
SEQFXLP iny				;RETURN POINT FOR CONTINUOUS SEQUENCE-EFFECT CHECKING
SEQFXL2 jsr SEQSUB		;READ NEXT DATA FROM SEQ (ORDERLIST)
		bpl SETPNUM		;IF BELOW $80, JUST GO SETTING SEQPOS & PATTERN-NUMBER NORMALLY
		cmp #$FE		;HARDWIRED SEQUENCE-DELIMITER (END)
		bne chkloop
a36		dec SPDCNT,x	;KEEP IT AWAY FROM COUNTING-UP
a37		jmp CNTPLAY		;CYCLECH ;IF $FE THEN END OF PLAYING (COUNTER STOPS AT '1' FOR TRACK)

chkloop	cmp #$FF		;HARDWIRED SEQUENCE-DELIMITER (JUMP/LOOP)
		beq LOOPSEQ		;IF NO FF AND ABOVE &80, DO SEQUENCE-FX (TRANSPOSE/REPEAT/ETC.)
a38		jsr SEQ_FX		;ACCU ABOVE $80 & BELOW $FE: HANDLE ORDERLIST/SEQUENCE-FX
		iny
a72		jsr SEQSUB		;CHECK NEXT VALUE IN SEQUENCE
		cmp #$FF		;IF $FF-COMMAND DIRECTLY AFTER SEQ-FX, DON'T ALLOW LOOPING (SAFETY CHECK TO PREVENT FREEZE)
		beq PTNPLAY		;SETSPOS ;IF ILLEGAL SEQFX-$FF SEQUENCE FOUND, SKIP LOOPING
		bne SEQFXL2		;GO BACK TO CHECK IF DELIMITER/SEQ-FX AT NEXT POSITION

LOOPSEQ 
		.if COMPILEDAPP=1
		cpy #0			;if $FF-loopsignal at position 0 we should prevent looping that causes freeze
		beq PTNPLAY
		.fi
		iny				;LOOP SEQUENCE TO GIVEN POSITION (AFTER $FF DELIMITER)
a40		jsr SEQSUB		;READ SEQ JUMP-ADDRESS (NEXT DATA IN ORDERLIST)
		bpl lpindex		;IF SIMPLE JUMP-ADDRESS (BELOW $80)
		.if feature.SUBTUNEJUMP_ON
a94b	jsr SETSEQA		;set Sequence-pointer for the track ;sta SUBTJMP+1	;CAUSE SUBTUNE-JUMPING IN PLAYER'S MAIN PART
		.fi
		lda #0
lpindex	tay
a41		jmp SEQFXL2		;AND ALSO READ THIS POSITION'S PTN-NUMBER/SEQ.FX

SETPNUM sta ACTPTN,x	;SET PATTERN-NUMBER TO ACCU
SETSPOS tya
a42		sta SEQPOS,x	;AND SET SEQ-POS TO
PTNPLAY ldy #0
SETPPO2 tya
a43		sta PTNPOS,x
		.if feature.FASTSPEEDBIND_ON
CHKTMP2 ldy TMPPOS,x	;CHECK IF TEMPO IS NOT BIGGER THAN 2
p_tmpt3 lda TEMPOTBL,y
		and #$7F
		cmp #3
		bmi TICK_2		;IF TEMPO IS NOT BIGGER THAN 2, DON'T DO HR1 BUT HANDLE NOTE/INS/FX
		.fi
		.if feature.HARDRESTYPES_ON
HRDR1FR lda #1			;STORE HR-TICK-TIMER-NUMBER
		.fi
a44		jmp HARDRST		;JUMP TO HARD-RESTART CHECKER & PERFORMER ROUTINE


;--------------------------------------------------------------------------------------
CHKTCK2 beq TICK_2		;COMPARE SPDCNT,X TO '2'
a45		jmp CNTPLAY		;HERE SPDCNT<>2, REST OF THE TICKS (ONLY CNTPLAY)
TICK_2
		.if (feature.PWRESETSW_ON + feature.FILTRESETSW_ON)
		ldy #%11111111	;SIGN LATER IF SELECTION OF INSTRUMENT HAPPENED OR NOT
		.fi
a46		lda ACTIFX,x	;CHECK INST/FX COLUMN
		beq CHKNOTE		;IF NOP, NOTHING TO DO
		cmp #maxinstamount;CHECK IF NORMAL INSTRUMENT (BELOW $3F)
		bpl CHKNOTE		;IF Y > MAX.INST.AMOUNT, SKIP INST.SELECTION
SEL_INS sta ACTINS,x	;SELECT INSTRUMENT IF Y IS IN RANGE 1..MAX.INST
		.if (feature.PWRESETSW_ON + feature.FILTRESETSW_ON)
		ldy #%00111111	;CAUSE FILTER&PW-TABLE TO RESET AT INSTRUMENT-SELECTION
CHKNOTE sty TABLRST+1	;SIGN FOR PW/CTF RESETTER IF INSTRUMENT WAS JUST SELECTED
		.else
CHKNOTE					;
		.fi

a47		ldy ACTINS,x	;PUT CURRENT INSTRUMENT'S BASE-ADDRESS TO ZEROPAGE-POINTERS
		bne STRTINS		;ONLY PERFORM REST OF TICK2 IF ANY INSTRUMENT IS SELECTED, SAVE RASTERTIME
a226	JMP LEGATOO
STRTINS					;ENTRY POINT USED BY PLAYADAPTER TO SET INSTRUMENT
p_insl4 lda INSPTLO,y	;Y IS NUMBER OF CURRENT INSTRUMENT
		sta PLAYERZP+0
p_insh4 lda INSPTHI,y
		sta PLAYERZP+1

COLUMN1 lda ACTNOT,x	;CHECK NOTE COLUMN
		bne chkinst		;IF NOP, NO NOTE-FX, CHECK FOR INSTRUMENT-/PATTERN-FX
a48		jsr INSPTFX		;INST/PATTERNFX. (nothing (NOP) was in note-column)
a49		jmp CNTPLY2		;SKIP POINTER-SETTING (WAS SET IN THIS TICK)

chkinst	cmp #$60		;CHECK IF NORMAL NOTE (BELOW $60)
		bmi CLEGATO		;IF A < $60 CHECK FOR LEGATO, IF A >= $60 DO NOTE-FX THEN INS/PTN-FX
a50		jsr NOTE_FX		;HANDLE NOTE/INS./PATTERN-EFFECTS, INPUT: ACCU
a51		jmp CNTPLY2

CLEGATO clc				;SETTING NOTE-PITCH FIRST BASED ON ACTNOT,X LOADED TO ACCU PREVIOUSLY
		.if feature.OCTAVESHIFT_ON
		ldy #9			;INDEX OF OCTAVE-SHIFT OF INSTRUMENT
		adc (PLAYERZP),y
		.fi
		.if feature.TRANSPOSESUPP_ON
		clc
a20b	adc TRANSP,x	;ADD 2'S COMPLEMENT TRANSPOSE-VALUE (SET BY SEQUENCE-FX)
		.fi
a52		sta DPITCH,x	;DISCRETE PITCH (0..$5F)

		lda #$03		;PORTAMENTO-BIGFX-VALUE?
a53		cmp ACTFX2,x	;CHECK IF PORTAMENTO-EFFECT IN THE ROW
		beq LEGATOO		;IF PORTAMENTO, NO INITIALIZATION OF SOUND NEEDED
a218	adc SLIDEVIB,x	;CHECK IF NOTE-FX PORTAMENTO ($FF) WAS INITIATED BEFOREHANDS
		bcs SETPRTA		;IF YES, DO TONE-PORTAMENTO (SPEED ALREADY CALCULATED BY PORTAMENTO NOTE-FX)
CHILEGA lda #$3F		;CHECK IF ACTIFX WAS $3F "LEGATO" ;IF $3F, TIED NOTE (LEGATO/HAMMER-ON), SKIP SOUND-INIT
a54		cmp ACTIFX,x	;CHECK ACTIFX (WITHOUT BIT 7), GET LEGATO INFO
		bne STRTSND		;IF NO LEGATO AND NO PORTAMENTO, NORMAL SOUND-START
SETLEGA lda #$7F		;BIG SPEED FOR PORTAMENTO IS EQUAL TO LEGATO
a55		sta FREQMODH,x	;MAXIMAL PORTAMENTO-SLIDE
SETPRTA lda #$83		;HANDLE NOTE-PITCH SETTING FOR LEGATO!!!
a56		sta SLIDEVIB,x	;SET PORTAMENTO
LEGATOO jsr INSPTFX		;INST/PATTERNFX. (WASN'T FX in note-column)
a71		jmp WRWFGHO		;WRITE 'WAVEFORM-CONTROL' SID-REGISTER ONLY (just in case if editor stopped at SPDCNT=2 phase, muting)

STRTSND					;STARTING THE SOUND - INIT ADSR, WAVEFORM-ARP, PULSEPROGRAM, FILTERPROGRAM, ETC.

		ldy #0			;INIT INSTRUMENT COUNTERS/POINTERS
		;READ CONTROL-BYTE OF INSTRUMENT FROM INDEX 0
		lda (PLAYERZP),y;(bit0-1:HRtimer,bit2:HRgateoff,bit3:TestbitHR,bit4-5:vib.type,bit6:pulseresetOFF,bit7-filtresetOff)
		.if (feature.PWRESETSW_ON + feature.FILTRESETSW_ON)
TABLRST and #$3F		;%00111111 ;SELF-WRITTEN - IF INSTRUMENT SELECTED, CAUSES TABLES TO RESET
		.fi
a57		sta INSCTRL+1	;STORE IT FOR LATER USES
		and #$30
a58		sta SLIDEVIB,x	;VIBRATO-CONTROL PART OF INSTRUMENT-CONTROL REGISTER

;--------upcoming parts can be arranged to provide good timing for the ADSR/WAVEFORM note-starter
;after so many trials it seems ADSR setting should be either very close or very far from WAVEFORM-setting 
;to produce reliable sound (otherwise, near treshold, some ADSR settings sound very unreliable on 1st frame)

INSCTRL lda #0			;SELF-WRITTEN, INSTRUMENT-CONTROL BYTE STORED
		.if feature.FRAME1SWITCH_ON ;CHECK IF WAVEFORM1 SWITCH DISABLED
		and #8			;1ST WAVEFORM-SETTING (SEXY TESTBIT-START IF ON)
		beq SETWFTP		;IF ZERO, DON'T INIT WAVEFORM-REGISTER
a96b	ldy DPITCH,x
a97b	lda FREQTBH,x
		.if feature.ALLGHOSTREGS_ON==0
		sta SIDBASE+1,x
		.else
a98b	sta SID1GHO,x
		.fi
SETWFR1 ldy #$0F		;POSITION OF 1ST FRAME WAVEFORM IN INSTRUMENT ($09 BY DEFAULT)
		lda (PLAYERZP),y;SET TEST-BIT (ORA #8) FOR 1ST FRAME ;CADAVER SAYS THAT $01 IS BETTER THAN $09/$89 AS 1ST FRAME WAVEFORM FOR NOISE
		.else			;IF SEXY-HARDRESTART SWITCH DISABLED
		lda #$09		;SIMPLER, ALWAYS 9 AT FRAME 1
		.fi
a65		sta WFGHOST,x	;1ST FRAME WAVEFORM
SETWFTP lda #WFTABLEPOS ;RESET WFTABLE COUNTER - can be overridden from Big-FX 4
a66		sta WFTPOS,x

		lda #$FF
a67		sta PTNGATE,x
a23b	sta ARPSCNT,x	;used for multispeed to determine note 1st frame
		.if feature.ARPSPEEDSUPP_ON
		ldy #7			;ARPSPEED OF INSTRUMENT
		lda (PLAYERZP),y
a24b	sta ARPSPED,x
		.fi

INSTVIB jsr SETVIB0		;SET VIBRATO-AMPLITUDE AND FREQUENCY AND FREQ.COUNTER

		.if feature.CHORDSUPPORT_ON
SETCHDP ldy #8			;DEFAULT CHORD FOR INSTRUMENT
		lda (PLAYERZP),y
a25b	sta ACTCHORD,x
		tay
p_chdp1 lda CHDPTRLO,y	;GET CHORD-BASEPOINTER
a26b	sta CHORDPOS,x	;SET BASE-INDEX OF CHORD IN CHORDTABLE
		.fi

		.if feature.PWRESETSW_ON
a21b	bit INSCTRL+1	;CHECK BIT6 - IF PW-RESET IS OFF FOR INSTRUMENT AND NO INST.SELECTION / MODIFICATION
		bvs ENDPWRESET	;BIT6 - PW RESET SWITCH
		.fi
		ldy #$0A		;RESET PWTABLE COUNTER
		lda (PLAYERZP),y
a59		sta PWTPOS,x
ENDPWRESET

		.if feature.FILTRESETSW_ON
a22b	bit INSCTRL+1	;INST.CONTROL BYTE
CHFLRST bmi ENDFILRESET	;CHECK BIT7 - IF CTF-RESET IS OFF FOR INSTRUMENT AND NO INST.SELECTION /MODIFICATION
		.else
CHFLRST ;
		.fi
		.if (COMPILEDAPP==1 && FILTER_MUTESOLO==1)  ;advised at CSDB 
		ldy playadapter.playmod
		beq +			;in stopped (jamming) mode no need to use mute/solo feature
		ldy playadapter.div7chn,x	;mute filter-program as well to avoid clicks on 6581 SID's muted channels
		lda mutesolo,y	;$FE or $FF
		cmp #$FE
		beq SWOFFLT
		+
		.fi
SETFLTP ldy #$0B		;RESET CTFTABLE COUNTER
		lda (PLAYERZP),y
		tay
		lda (PLAYERZP),y;READ FROM 1ST ROW OF FILTERTABLE
		beq SWONFLT		;IF $00 IN 1ST ROW, INSTRUMENT IS FILTERED BUT DOESN'T CONTROL FILTER
		cmp #$FF		;IF $FF, INSTRUMENT NOT FILTERED, SWITCHING FILTERSWITCH ON/OFF
		beq SWOFFLT
a60		stx FLTCTRL+1	;MAKE ACTUAL INSTRUMENT THE FILTER-CONTROLLER FOR SID
a61		sty FLTPOSI+1
SWONFLT lda FLSWTBL,x
a62		ora FSWITCH+1	;SWITCH ON SID-FILTER FOR INSTRUMENT (CHANNEL) - 'OR' BIT IN SWITCH-BIT TABLE
		bne a64			;JMP +
SWOFFLT lda FLSWTB2,x
a63		and FSWITCH+1	;SWITCH OFF SID-FILTER FOR INSTRUMENT (CHANNEL) - 'XOR' BIT IN SWITCH-BIT TABLE
a64		sta FSWITCH+1
ENDFILRESET

SETADSR ldy #3			;AD
		lda (PLAYERZP),y;READ 'ATTACK/DECAY'
		.if feature.ALLGHOSTREGS_ON==0
		sta SIDBASE+5,x ;ADTEMP - ALLOW PATTERN-FX
		.else
a112b	sta ADGHOST,x
		.fi
		iny				;4 ;SR
		lda (PLAYERZP),y
		.if feature.ALLGHOSTREGS_ON==0
		sta SIDBASE+6,x ;SRTEMP - ALLOW PATTERN-FX
		.else
a113b	sta SRGHOST,x
		.fi

a230	jsr INSPTFX		;INST/PATTERNFX. (WASN'T FX in note-column)
a231	jmp WRWFGHO		;WRITE SID-REGISTER (WAVEFORM-CONTROL)


;------------------------------------------------------------------------
CNTPLAY ldy ACTINS,x	;PUT CURRENT INSTRUMENT'S BASE-ADDRESS TO ZEROPAGE-POINTERS
		bne CNTPLY1		;ONLY PERFORM CNTPLAY IF THERE'S ANY INSTRUMENT SELECTED
		rts				;JMP RETRACK
CNTPLY1					;
p_insl5 lda INSPTLO,y	;Y IS NUMBER OF CURRENT INSTRUMENT
		sta PLAYERZP+0
p_insh5 lda INSPTHI,y
		sta PLAYERZP+1
CNTPLY2					;CONTINUOUS PLAY - SLIDE,VIBRATO,SWEEP,TABLES,ETC.


VIBSLIDE				;VIBRATO AND SLIDE/PORTAMENTO PATTERN-FX AS WELL (A BIT TRICKY)
a75		ldy SLIDEVIB,x	;READ SLIDE/PORTAMENTO/VIBRATO TYPE FROM INST.CONTROL BYTE
		.if feature.VIBRATOTYPES_ON
		beq INCVIBR		;INCREASING TYPE OF VIBRATO?
		.fi
		bpl NORMVIB		;IF BELOW $80, IT'S NORMAL VIBRATO
SLIDES	cpy #$82		;DECIDE WHICH KIND OF SLIDE - SETTING CARRY-FLAG AND N-FLAG
		beq SUBFREQ		;IF $82
		bpl +
a225	jmp ADDFREQ		;IF $81
		+
		.if feature.PORTAVIBRA_ON=1
		cpy #$FF		;portamento Note-FX?
		beq TARGETN		;then just continue vibrato yet (for this row)
		.fi
PORTAME ldy DPITCH,x	;HANDLE PORTAMENTO
a76		lda FREQTBL,y	;COMPARE TO DESIRED NOTE AFTER PORTAMENTO
a77		sbc FREQLO,x	;SET CARRY
a78		sta STORFRL+1	;STORE DIFFERENCE LO-BYTE
a79		lda FREQTBH,y	;HI-BYTE OF DESIRED NOTE-PITCH
a80		sbc FREQHI,x	;COMPARE WITH CARRY
		tay				;STORE DIFFERENCE HI-BYTE
STORFRL lda #0			;SELF-WRITTEN PREVIOUSLY - STORED LO-BYTE OF DIFFERENCE
		bcs PORTAUP		;IF DESIRED PITCH IS BIGGER THAN ACTUAL PITCH, DO PORTAMENTO-UP
PORTADN adc FREQMODL,x	;PORTAMENTO-DOWN
		tya				;RESTORE HI-BYTE OF DIFFERENCE
a81		adc FREQMODH,x	;TEST HI-BYTE
		bcc SUBFREQ		;IF DESIRED NOTE IS NOT REACHED YET
PORTEND	;player jumped here when the target-note frequency was reached for portamento
		.if feature.PORTAVIBRA_ON=1
a200b	jsr FORCVIB ;reset SLIDEVIB for instrument
a201b	jsr SETVIB1 ;reset vibrato of instrument after slide
		.fi
TARGETN	ldy DPITCH,x
a82		lda FREQTBL,y	;LO-BYTE OF DESIRED PITCH
a83		sta FREQLO,x	;DESIRED NOTE WAS REACHED, END OF PORTAMENTO, SET EXACT FREQUENCY
a84		lda FREQTBH,y	;HI-BYTE OF DESIRED PITCH
a85		jmp STORVHI

NORMVIB ldy VIDELCNT,x	;HANDLE VIBRATO-DELAY IN CASE OF NORMAL VIBRATOS
		bmi DOVIBRA		;IF DELAY-COUNTER FINISHED
a86		dec VIDELCNT,x
a87		jmp ENDVIBSLIDE

		.if feature.VIBRATOTYPES_ON
INCVIBR lda FREQMODL,x
		clc				;LDA FREQMODL,X ;WAS LOADED PREVIOUSLY INTO ACCU
a28b	adc VIDELCNT,x	;AMPLITUDE-INCREASE RATIO IS TAKEN FROM VIBRATO-DELAY DATA
a29b	sta FREQMODL,x
		bcc DOVIBRA
a30b	inc FREQMODH,x
		.fi
DOVIBRA lda VIBRACNT,x
		bne decVcnt		;IF NOT ZERO (COUNTED DOWN) SIMPLY SUBSTRACT 1 (OR NOTHING, IF SLIDE)
a88		lda VIBFREQU,x
decVcnt	sec
		sbc #1
a89		sta VIBRACNT,x
		asl				;IF HALF OF COUNTER REACHED, CHANGE VIBRATO-SLIDE-DIRECTION
a90		cmp VIBFREQU,x	;SET CARRY BIT BASED ON WHICH HALF THE FREQUENCY COUNTER IS IN
		bcc ADDFREQ		;CARRY IS SET HERE CORRECTLY, NO NEED TO INITIALIZE IN NEXT STEP
SUBFREQ lda FREQLO,x
a91		sbc FREQMODL,x	;SUBSTRACT LOW-BYTE PART, SET CARRY-BIT
a92		sta FREQLO,x
a93		lda FREQHI,x
a94		sbc FREQMODH,x	;SUBSTRACT HIGH-BYTE PART AND CARRY-BIT
a95		jmp STORVHI

PORTAUP sbc FREQMODL,x	;PORTAMENTO-UP
		tya				;RESTORE HI-BYTE OF DIFFERENCE
a96		sbc FREQMODH,x	;TEST HI-BYTE
		bcc PORTEND		;IF DESIRED NOTE IS REACHED, END OF PORTAMENTO, SET EXACT FREQUENCY
ADDFREQ lda FREQLO,x	;PREFETCH DATA
a97		adc FREQMODL,x	;ADD LOW-BYTE PART, SET CARRY-BIT
a98		sta FREQLO,x
a99		lda FREQHI,x
a100	adc FREQMODH,x	;ADD HIGH-BYTE PART AND CARRY-BIT
STORVHI sta FREQHI,x
ENDVIBSLIDE

;FILTER-RESO-CUTOFF-BAND HANDLING --- DETECTS FILTER-CONTROLLER CHANNEL!!!!
FLTCTRL cpx #0			;SELF-WRITTEN ;CHECK WHICH CHANNEL CONTROLS THE FILTER
		bne ENDFLTB,a105;IF NOT ACTUAL TRACK, DONT'T RUN ITS FILTER-TABLE

FLTPOSI ldy #0			;SELF-WRITTEN -FILTERTABLE-POSITION OF ACTUAL FILTER-CONTROLLER TRACK
		lda (PLAYERZP),y;FILTERTABLE 1ST COLUMN BAND-RESO. / FILTERSWEEP-CYCLECOUNT
		bmi NOCWEEP		;IF FILTER-SETTING OR JUMP IN ACTUAL POSITION
FISWEEP iny				;POINT TO 2ND COLUMN
CWEPCNT cmp #0			;SELF-WRITTEN - FILTER CUTOFF-FREQUENCY SWEEP COUNTER
		beq FLADVAN		;;IF SWEEP-PROGRAM REACHED ITS END, ADVANCE TO NEXT TABLE-ROW
a102	inc CWEPCNT+1
		clc				;CARRY=0 - TREAT $FF AS -1 IN UPCOMING FINE CUTOFF-SWEEP
		lda (PLAYERZP),y;CUTOFF SIGNED AMOUNT TO ADD/SUBSTRACT IN ONE FRAME
		.if feature.FINEFILTSWEEP_ON
		bpl CWEEPUP		;IF POSITIVE (BIT7=0) ADD VALUE, OTHERWSE SUBSTRACT
CWEEPDN ora #$F8		;SART SUBSTRACTING 7-BIT VALUE FROM 8+3 BIT VALUE
a31b	adc CTFLGHO+1	;#0 ;SELF-WRITTEN
		php				;STORE CARRY-BIT
		and #7
a32b	sta CTFLGHO+1
		lda (PLAYERZP),y;CUTOFF SIGNED AMOUNT TO ADD/SUBSTRACT IN ONE FRAME
		eor #$FF
		lsr
		lsr
		lsr
		eor #$FF
a33b	jmp strFswp

CWEEPUP and #7			;SART ADDING 7-BIT VALUE TO 8+3 BIT VALUE
a34b	adc CTFLGHO+1	;CLC NOT NEEDED ;CARRY-BIT WAS SET BEFORE
		cmp #8			;SETS CARRY IF LOW 3 BITS OVERLOADED
		php				;STORE CARRY
		and #7
a35b	sta CTFLGHO+1
		lda (PLAYERZP),y;CUTOFF SIGNED AMOUNT TO ADD/SUBSTRACT IN ONE FRAME
		lsr
		lsr
		lsr
strFswp	plp				;GET CARRY BACK
		.fi				;END OF FINE (11BIT) FILTERSWEEP-CHECKING
a103	adc CTFHGHO+1
a104	sta CTFHGHO+1
a105	jmp ENDFLTB

NOCWEEP cmp #$FE		;....LOOP/JUMP COMMAND ?
		beq FLTJUMP		;CHECK IF $FE JUMP-COMMAND
		bcc SETFILT		;IF $80 >= BUT < $FE, SET FILTER
		bcs ENDFLTB		;IF $FF FILTERTABLE-ENDSIGNAL, DO NOTHING

FLTJUMP iny				;POINT TO JUMP-ADDRESS IN 2ND COLUMN
		lda (PLAYERZP),y;JUMP-ADDRESS
a107	cmp FLTPOSI+1	;,X
		beq ENDFLTB		;IF JUMPING TO ITSELF, NO NEED TO EXECUTE ANY JUMPING, BUT RESTING INSTEAD
		tay
		lda (PLAYERZP),y;READ 1ST COLUMN FROM JUMP-TARGET ADDRESS
		bpl SETFPOS		;IF BELOW $80, JUST INIT FOR SWEEP COMING IN NEXT TURN
SETFILT pha				;SET FILTER, IF 1ST NIBBLE IS MORE THAN 8, AND NOT $FE/$FF
		and #$70		;MASK FOR FILTERBAND-SWITCHES
a108	sta FLTBAND+1	;SET FILTER-BAND
		pla
		asl				;GET AND SHIFT RESONANCE NIBBLE - x8 FIRST
		asl
		asl
		asl				;x16
a109	sta RESONIB+1	;RESONANCE-NIBBLE
		iny				;POINT TO 2ND COLUMN
		lda (PLAYERZP),y;CUTOFF-HI VALUE
a110	sta CTFHGHO+1	;SET CUTOFF-HI..
		.if feature.FINEFILTSWEEP_ON
		lda #0
a36b	sta CTFLGHO+1	;SET CUTOFF-LO..
		.fi
FLADVAN iny				;POINT TO 3RD COLUMN
		.if feature.FILTKBTRACK_ON
		lda (PLAYERZP),y
		bpl a37b ;A < $80?
		cmp #$90 ;A > $8F?
		bcs a37b
		and #$0f
a131b	sta FSWITCH+1
		lda #0
a37b	sta CKBDTRK+1	;READ AND ACK. KEYBOARD-TRACK FOR FILTER
		.fi
		iny				;POINT TO NEXT ROW 1ST COLUMN
SETFPOS sty FLTPOSI+1
		lda #0
a112	sta CWEPCNT+1	;INITIALIZE SWEEP-COUNTER AFTER SETTING PW...
ENDFLTB

;PULSEWIDTH-TABLE HANDLING
SETPWID ldy PWTPOS,x
		lda (PLAYERZP),y;PWTABLE 1ST COLUMN PW-HI-NIBBLE / PW-SWEEP-CYCLECOUNT
		bmi NOPWEEP		;IF PW-SETTING OR JUMP IN ACTUAL POSITION
PWSWEEP iny				;POINT TO 2ND COLUMN
a113	cmp PWEEPCNT,x	;IF SWEEP-PROGRAM REACHED ITS END
		beq PWADVAN		;THEN ADVANCE TO NEXT PWTABLE-ROW
a114	inc PWEEPCNT,x
		lda (PLAYERZP),y;PW SIGNED AMOUNT TO ADD/SUBSTRACT IN ONE FRAME
		bpl positPW		;DECIDE IF ADD/SUBSTRACT, PRE-DECREMENT HI-BYTE IS KINDA SUBSTRACTION
a115	dec PWHIGHO,x
positPW	clc				;NOT NECESSARY IF PRECISION NOT NEEDED, AS CARRY WAS SET TO 1 PREVIOUSLY BY 'CMP PWEEPCNT,X'
a116	adc PWLOGHO,x
a117	sta PWLOGHO,x
		bcc ENDPWTB
a118	inc PWHIGHO,x
		bcs ENDPWTB

NOPWEEP cmp #$FE		;....LOOP/JUMP COMMAND ?
		beq PWTJUMP		;CHECK IF $FE JUMP-COMMAND
		bcc SETPULW		;IF $80 >= BUT < $FE, SET PULSEWIDTH
		bcs ENDPWTB		;IF $FF PWTABLE-ENDSIGNAL, DO NOTHING

PWTJUMP iny				;POINT TO JUMP-ADDRESS IN 2ND COLUMN
		lda (PLAYERZP),y;JUMP-ADDRESS
a121	cmp PWTPOS,x
		beq ENDPWTB		;IF JUMPING TO ITSELF, NO NEED TO EXECUTE ANY JUMPING, BUT RESTING INSTEAD
		tay
		lda (PLAYERZP),y;READ 1ST COLUMN FROM JUMP-TARGET ADDRESS
		bpl SEPWPOS		;IF BELOW $80, JUST INIT FOR SWEEP COMING IN NEXT TURN
SETPULW and #$7F		;SET PULSEWIDTH, IF 1ST NIBBLE IS MORE THAN 8, AND NOT $FE/$FF
a122	sta PWHIGHO,x
		iny				;POINT TO 2ND COLUMN
		lda (PLAYERZP),y;PW-LOW VALUE
a123	sta PWLOGHO,x
PWADVAN iny				;POINT TO 3RD COLUMN
		.if feature.PWKEYBTRACK_ON
		lda (PLAYERZP),y;READ AND ACK. KEYBOARD TRACK FOR PW
a38b	sta PKBDTRK,x
		.fi
		iny				;POINT TO NEXT ROW 1ST COLUMN
SEPWPOS tya
a124	sta PWTPOS,x
		lda #0
a125	sta PWEEPCNT,x	;INITIALIZE SWEEP-COUNTER AFTER SETTING PW...
ENDPWTB
		.if feature.PWKEYBTRACK_ON
		clc				;PRE-SET CARRY
a39b	lda PKBDTRK,x	;ADJUST STEPPING-AMOUNT PER NOTE (KINDA DIVISION USING EXP.TABLE)
		beq a43b		;IF NO KEYBOARD-TRACKING (NO DIVISION WITH ZERO)
a40b	adc DPITCH,x	;A=ACTUAL NOTE ON ACTUAL TRACK
		tay
a41b	lda EXPTABH,y	;TRANSFORM ADDITION/SUBSTRACTION TO QUASY MULTIPLICATION/DIVISION
a42b	sbc EXPTABH-1,y ;FURTHER DIVIDE THE VALUE TO FIT IN 4 UPPER BITS OF PULSEWIDTH
a43b	adc PWHIGHO,x	;UPPER 4 BITS OF PULSEWIDTH, ONLY THIS KB.TRACKED FOR SPEED REASONS
		.else
a44b	lda PWHIGHO,x	;UPPER 4 BITS OF PULSEWIDTH
		.fi
		.if feature.ALLGHOSTREGS_ON==0
		sta SIDBASE+3,x
		.else
a114b	sta SID3GHO,x
		.fi
		.if COMPILEDAPP=1;HELP EDITOR TO DISPLAY PULSEWIDTH WITH KEYBOARD-TRACK
		sta playadapter.PWHIHELP,x
		.fi
a126	lda PWLOGHO,x
		.if feature.ALLGHOSTREGS_ON==0
		sta SIDBASE+2,x ;LOWER 8 BITS OF PULSEWIDTH
		.else
a115b	sta SID2GHO,x
		.fi

WFARPTB
		.if feature.ARPSPEEDSUPP_ON
a45b	dec ARPSCNT,x	;DECREASE ARPEGGIO-SPEED COUNTER
		bpl SKIPWFT
a46b	lda ARPSPED,x
		.fi
		and #$3F		;whatever Accu is, this 'AND #$3F' will make it 'positive' for multispeed-detector
a47b	sta ARPSCNT,x	;used by multispeed to determine new note 1st waveform (set to $FF by frame1)
RDWFROW ldy WFTPOS,x
		lda (PLAYERZP),y
		cmp #$FE		;....LOOP/JUMP COMMAND ?
		beq WFAJUMP		;IF $FE JUMP-COMMAND
		bcc WFTdone		;IF $FF WFTABLE-ENDSIGNAL, DO NOTHING
SKIPWFT jmp ENDWFTB		;WHEN COUNTER NOT COUNTED DOWN
WFTdone
		.if feature.ARPSPEEDSUPP_ON
		cmp #$10		;TRESHOLD BETWEEN ARPSPEED/WAVEFORM-SETTING
		bcs SEWFARP		;IF $00..$0F ARP-SPEED CHANGE (REPEAT $XX TICKS) - IN CASE OF 0, NOP - NO REPEAT
a48b	sta ARPSCNT,x
		bcc SETJARP
		.else
		bcc SEWFARP
		.fi
WFAJUMP iny				;SET REAL ADDRESS (MUL3)
		lda (PLAYERZP),y;READ JUMP-ADDRESS NEXT TO $FE
		bmi ENDWFTB		;IF BIGGER THAN JUMP ROW IS BIGGER THAN $2B (ADDRESS IS BIGGER THAN 3*$28+8)
a127	sta WFTPOS,x
		tay				;INDEX TO JUMP-ADDRESS
		lda (PLAYERZP),y;READ WAVEFORM-COLUMN FROM JUMP-TARGET ADDRESS
SEWFARP and PTNGATE,x
a128	sta WFGHOST,x
SETJARP iny				;2 CYCLES
		lda (PLAYERZP),y;ARP.ABS/REL PITCH ;6 CYCLES
		iny				;2 CYCLES
		.if feature.CHORDSUPPORT_ON
		cmp #$7F		;CHECK IF JUMPING TO CHORD
		beq PLYCHRD		;BNE NORMARP ;IF $7F, HANDLE CHORD INSTEAD OF WF-TABLE ARPEGGIO-COLUMN & DON'T ADVANCE IN TABLE
		.fi
a129	sta ASTOREZ+1	;4 CYCLES
		.if feature.DETUNESUPPORT_ON
		lda (PLAYERZP),y;6 CYCLES
		cmp #$FF ;detune-NOP?
		beq +
a203b	sta DETUNER,x
		+
		.fi
		iny				;2 CYCLES
		tya				;2 CYCLES
a131	sta WFTPOS,x	;5 CYCLES
ASTOREZ lda #0			;SELF-WRITTEN - STORED PITCH-VALUE (ARP.COLUMN)

NORMARP bpl RELPTCH		;IF REL.PITCH-UP (CARRY WAS SET BY 'CMP #$7F') - GOOD ENTRY POINT FOR 1ST WAVEFORM
		cmp #$80		;NOP?
		beq ENDWFTB		;DON'T CHANGE PITCH IF NOP
		cmp #$E0
		bcc ABSPTCH		;IF ABSOLUTE PICTH
		.if feature.CHORDSUPPORT_ON
		bcs RELPTCH		;IF REL.PITCH-DOWN

PLYCHRD lda (PLAYERZP),y;6 CYCLES
a52b	sta DETUNER,x
a53b	ldy CHORDPOS,x	;READ CHORDNOTE AT PLAYED CHORD-INDEX
p_chdt1 lda CHORDS,y	;LOAD RELATIVE CHORD-PITCH
		cmp #$7E		;$7E? - RETURN FROM CHORD TO WFARP-TABLE?
		bne chLoopC
a54b	ldy ACTCHORD,x	;LOOP TO BEGINNING OF ACTUAL CHORD
p_chdp2 lda CHDPTRLO,y	;GET CHORD-BASEPOINTER
a55b	sta CHORDPOS,x	;RESET PLAYED CHORD-INDEX TO PREPARE FOR NEXT POSSIBLE CHORD-LAUNCH
a56b	lda WFTPOS,x	;INDEX OF ACTUAL ROW
		adc #3-1		;CARRY IS 1 AFTER 'CMP' DIDN'T UNDERFLOW, SO MUST BE SUBSTRACTED
a57b	sta WFTPOS,x
a58b	jmp RDWFROW		;RDWFORM ;GO TO BEGINNING OF NEXT ROW
chLoopC	cmp #$7F		;$7F? - LOOP CHORD?
		bne DOCHORD
LOOPCHD ldy ACTCHORD,x	;LOOP TO BEGINNING OF ACTUAL CHORD
p_chdp3 lda CHDPTRLO,y	;GET CHORD-BASEPOINTER
a59b	sta CHORDPOS,x
		tay
p_chdt2 lda CHORDS,y	;LOAD RELATIVE CHORD-PITCH
DOCHORD inc CHORDPOS,x	;ADVANCE IN PLAYED CHORD-INDEX
		.fi				;END OF CHECKING CHORD-SUPPORT

RELPTCH clc				;ADD VALUE TO DISCRETE NOTE-PITCH
a132	adc DPITCH,x
ABSPTCH and #$7F		;FOR ABSOLUTE PITCH
		tay
a133	lda FREQTBL,y
a134	sta FREQLO,x	;HANDLE PITCH-DETUNING (DELAYED VIBRATO STILLAPPLICABLE)
a135	lda FREQTBH,y
a136	sta FREQHI,x
ENDWFTB
;-----------------------
WRPITCH lda FREQLO,x	;
		.if feature.DETUNESUPPORT_ON
a202b	adc DETUNER,x	;RESTORE DETUNE-VALUE - 2 CYCLES
		.fi
		.if feature.ALLGHOSTREGS_ON==0
		sta SIDBASE+0,x
		.else
a116b	sta SID0GHO,x
		.fi
a137	lda FREQHI,x
		.if feature.DETUNESUPPORT_ON
		adc #0			;ADD CARRY (IF DETUNER HAS UPPER PART)
		.fi
		.if feature.ALLGHOSTREGS_ON==0
		sta SIDBASE+1,x
		.else
a117b	sta SID1GHO,x
		.fi
		
;-------------------------------------------
WRWFGHO lda WFGHOST,x
		.if COMPILEDAPP=1;muting in editor
		ldy playadapter.playmod
		beq skpMute		;in stopped (jamming) mode no need to use mute/solo feature
		ldy playadapter.div7chn,x
		and mutesolo,y	;$FE or $FF
		jmp endMute
skpMute	and playadapter.wasjamm,x   ;mutes sound after directly pausing / switching instrument until a key is pressed for jamming
endMute	
		.fi
WRSIDR4	.if feature.ALLGHOSTREGS_ON==0
		sta SIDBASE+4,x ;WAVEFORM-CONTROL SID-REGISTER
		.else
a118b	sta SID4GHO,x
		.fi
		
;-----------------------------------------------------------
RETRACK rts				;RETURN FROM ACTUAL SID-TRACK


;****************************COMMON SUBROUTINES********************************
SETSTUNE ;SET SUBTUNE, INPUT: SUBTUNE-NUMBER MUST BE GIVEN IN ACCU (0..F)
		ldx #7*0
a232	jsr SETSEQA ;SET SEQUENCE ON ONE TRACK (USED BY SUBTUNE-JUMP FX); INPUT: SUBTUNE IN ACCU, CHANNEL IN X (0/7/14)
		ldx #7*1
a233	jsr SETSEQB ;SET SELECTED SUBTUNE'S SEQUENCE ON ONE TRACK; INPUT: CHANNEL IN X (0/7/14)
		ldx #7*2
a234	jsr SETSEQB ;SET SELECTED SUBTUNE'S SEQUENCE ON ONE TRACK; INPUT: CHANNEL IN X (0/7/14)
		iny 		; Y = subtune funktempo position  - using return value in Y after 3rd channel SETSEQ
p_subt3 lda SUBTUNES,y ;COPY SUBTUNE-FUNKTEMPO1 TO TEMPOTABLE PLACE 0
p_tmpt4 sta TEMPOTBL+0
p_subt4 lda SUBTUNES+1,y ;COPY SUBTUNE-FUNKTEMPO2 TO TEMPOTABLE PLACE 1
p_tmpt5 sta TEMPOTBL+1
		rts

SETSEQA	;SET SEQUENCE ON ONE TRACK (USED BY SUBTUNE-JUMP FX); INPUT: SUBTUNE IN ACCU, CHANNEL IN X (0/7/14) - X PRESERVED
		.if feature.SUBTUNEJUMP_ON
a93b	stx XSTORE+1 ;retain X
		.fi
		;and #$1F	;unneeded because upcoming 'asl' throws higher bits ;clear bit7 (and other bits to restrict number of subtunes)
		asl			;GET SUBTUNE ADDRESS FROM ACCU MULTIPLIED 8 -ASL;ASL;ASL
		asl
		asl
a235	sta SUBTPOS+1 ;temporary starage for calculated subtune-position
SETSEQB	lda TRKTMPOS,x	;A = 2|4|6 depending on track given in X (0/7/14)
		asl ;A=4|8|12 ;carry=0
		sbc #3-1 ;A = A-(3-CARRY) = 1|5|9 
		tax ;X=1|5|9 **************
		lsr ;A=0|2|4 ;carry=1 unfortunately
		clc
SUBTPOS	adc #0			;self-written - stored calculated base-position of subtune-data (seq.pointers and funktempo)
		tay ;Y=SUBTUNEBASE + 0|2|4 *************
p_subt1 lda SUBTUNES,y	;READ ORDERLIST LO-ADDRESSES FOR SUBTUNE
a138	sta p_seqt1,x	;SET ORDERLIST LO-ADDRESSES FOR SUBTUNE
		iny
p_subt2 lda SUBTUNES,y ;READ ORDERLIST HI-ADDRESSES FOR SUBTUNE
a139	sta p_seqt1+1,x	;SET ORDERLIST HI-ADDRESSES FOR SUBTUNE
		.if feature.SUBTUNEJUMP_ON
XSTORE	ldx #0 ;restore X
		.fi
		rts
;SOURCE:  SUBT[A] + 0-1, 2-3, 4-5     SUBT[A]  + 6,7
;DESTIN:  p_seqt1 + 1-2, 5-6, 9-10    TEMPOTBL + 0,1

;-----------------------
SEQSUB	cpx #7*1		;SEQUENCE (ORDERLIST) READER SUBROUTINE,Y=POS.
		beq p_seqt2		;CALLED AS SUBROUTINE,READS TRACK-SEQ OF REG.X
		bpl p_seqt3
p_seqt1 lda SEQUENCES,y ;LOAD PTNUM/FX FROM TRACK 0 ORDERLIST
		rts
p_seqt2 lda SEQUENCES,y ;LOAD PTNUM/FX FROM TRACK 1 ORDERLIST
		rts
p_seqt3 lda SEQUENCES,y ;LOAD PTNUM/FX FROM TRACK 2 ORDERLIST
		rts

;-------------------------------------------------------------------------------
		.if feature.CALCVIBRATO_ON;DIFFERENT EXPONENT-TABLE BASES AND TRESHOLD FOR CALCULATED VIBRATO
EXPTBASE = EXPTABH
		.else
EXPTBASE = FREQTBH-1
		.fi
EXPTRESHOLD = ENDFREQTBH-EXPTBASE

SETVIB0	ldy #6			;READ VIBRATO-DELAY/INCREMENT AMOUNT FROM INSTRUMENT-DATA
		lda (PLAYERZP),y
a69		sta VIDELCNT,x	;MAX.$7F, COUNTS BACK TILL $FF
SETVIB1	ldy	#5			;5 INDEX TO VIBRATO FREQUENCY AND AMPLITUDE INSTRUMENT-DATA
		lda (PLAYERZP),y
SETVIBR pha				;SET AMPLITUDE AND FREQUENCY OF VIBRATO. INPUT: ACCU (HI-NIBBLE IS AMPLITUDE)
		and #$0F
		asl				;ASL, BIT 1 IS ALWAYS 0, SO IT CAN BE CLIPPED INTO 2 EQUAL TIMEFRAMES FOR SLIDE UP/DOWN
a208	sta VIBFREQU,x
		lsr				;HALF-TIMERSTART FOR DOWN-ORIENTED VIBRATO (LIKE GUITAR TREMOLO-ARM)
		.if feature.VIBRATOTYPES_ON
a27b	ldy SLIDEVIB,x	;SELF-WRITTEN CODE - VIBRATO-CONTROL-EXACT FROM INSTRUMENT-CONTROL REGISTER
		cpy #$20
		bpl chUpVib		;NOT INCREASING-TYPE VIBRATO OR DEFAULT VIBRATO?
		.fi
		lsr				;FOR QUARTER TIMERSTART - NORMAL VIBRATO
		.if feature.VIBRATOTYPES_ON
chUpVib	cpy #$30
		bne a70
		lda #0			;0 TIMERSTART FOR UP-ORIENTED VIBRATO (LIKE GUITAR STRING STRETCHING)
		.fi
a70		sta VIBRACNT,x
		pla
SETVAMP and #$F0		;SET AMPLITUDE (NO NEED TO MASK OUT FREQ.NIBBLE AS IT'S NOT SIGNIFICANT
		lsr				;0..127
SETFMOD					;SET FREQUENCY-MODIFIER VALUES FOR SLIDE/PORTAMENTO, OR RESET THEM IF NO SLIDE/VIBRATO
		.if feature.CALCVIBRATO_ON
		beq a213		;IF 0, NO CALCULATION OF PITCH
		lsr				;vibrato-0..64, slide-0..127
a95b	adc DPITCH,x	;vibrato-0..160, slide-0..222 , CALCULATE PITCH-DEPENDENT AMPLITUDE-COMPENSATION HERE!!!!
		.fi
LOOKUPA tay				;0..LOOK UP AMPLITUDE VALUE FROM FREQUENCY/EXPONENT-TABLES
CHKTEND cpy #EXPTRESHOLD+(ENDFREQTBH-FREQTBH)
		bcs MAXSLID		;IF POINTS OVER TABLE
		cpy #EXPTRESHOLD;DECIDE ON FINE/ROUGH HALF OF THE EXPONENT-TABLE
		bcs a214		;if bigger than $60 limit of table, switch to rough table
a212	lda EXPTBASE,y
a213	sta FREQMODL,x
		lda #0			;IN FINE-RANGE FREQ-ADD-HI SHOULD BE 0
		beq a217		;jump
MAXSLID ldy #EXPTRESHOLD+(ENDFREQTBH-FREQTBH)
a214	lda FREQTBL-EXPTRESHOLD,y
a215	sta FREQMODL,x
a216	lda FREQTBH-EXPTRESHOLD,y;EXPTABH,Y ;EXPONENTIAL TABLE SIMULATES MULTIPLICATION - CALCULATED VIBRATO
a217	sta FREQMODH,x
		rts

;******************************* NUMERIC DATA *********************************
;SID EQUAL-TEMPERED frequency table:
;----------------------------------------------------
;EXPONENT-TABLE HI-BYTES (USED FOR MULTIPLICATION)
		.if (feature.CALCVIBRATO_ON+feature.PWKEYBTRACK_ON+feature.FILTKBTRACK_ON+(COMPILEDAPP==1))
EXPTABH .byte 0,0,0,0,0,0,0,0, 0,0;LET EXPONENT TABLE BE A BIT MORE COMPLETE (FOR SUBSTRACTING KB.TRACK)
		.fi				;USED AS CALCULATED VIBRATO-AMPLITUDE TABLE TOO
		.byte 0			;FOR UNCALCULATED ZERO VIBRATO
FREQTBH .byte $01, $01,$01, $01,$01,$01;0  ;13  ;16TH ELEMENT IS $01 IN EXP.TABLE  ;be aware: C-1 note is the second value!
		.byte $01,$01,$01,$01,$01,$01;6   ;19
		.byte $02,$02,$02,$02,$02,$02;12  ;25
		.byte $02, $03,$03,$03,$03,$03;18 ;31  ;32ND ELEMENT IS $03 IN EXP.TABLE
		.byte $04,$04,$04,$04,$05,$05;24  ;37  ;!!! $04 IS 37TH ELEMENT IN EXP.TABLE
		.byte $05,$06,$06,$06,$07, $07;30 ;43  ;48TH ELEMENT IS $07 IN EXP.TABLE
		.byte $08,$08,$09,$09, $0a,$0a;36 ;49  ;!!!! $0A IS 53TH ELEMENT IN EX.TABLE
		.byte $0b,$0c,$0d,$0d,$0e, $0f;42 ;55  ;$0F IS 60TH ELEMENT IN EXP.TABLE
		;-------------------------------------
		.byte $10,$11,$12, $13,$14,$15;48 ;61 ;!!!64TH (72-8) ELEMENT IS $13 ($1F-$0C) IN EXP.TABLE
		.byte $17, $18,$1a,$1b,$1d, $1f;54;67 ;!!!! $1F ($2E-$0F) IS 72ND (64+8) ELEMENT IN EXP.TABLE,!!!$18 ($0A+$0E) IS 68TH
		.byte $20,$22, $24,$27,$29,$2b;60 ;73  ;$24 IS 75TH ELEMENT IN EXP.TABLE
		.byte $2e,$31, $34,$37,$3a, $3e;66;79 ;!!!$2E ($1F+$0F) IS 79TH (72+7), $3E IS 84TH, 80TH ELEMENT IS $31 IN EXP.TABLE
		.byte $41,$45,$49,$4e,$52,$57;72  ;85
		.byte $5c,$62,$68,$6e,$75,$7c;78  ;91
		.byte $83,$8b,$93,$9c,$a5,$af;84  ;97
		.byte $b9,$c4,$d0,$dd,$ea,$f8;90  ;103
ENDFREQTBH
		.if (feature.CALCVIBRATO_ON+feature.PWKEYBTRACK_ON+feature.FILTKBTRACK_ON+(COMPILEDAPP==1))
		.byte $F9,$FA,$FB,$FC,$FD,$FE,$FF,$FF;EXPAND EXPONENT-TABLE WITH SLOPE FOR KB.TRACKING
		.fi
ENDEXPTABH
;------------------------------------------------------------------------------
FREQTBL
		.byte $07, $16,$27,$38,$4b,$5e ;be aware: C-1 note is the second value!
		.byte $73,$89,$a1,$ba,$d4,$f0
		.byte $0d,$2c,$4e,$71,$96,$bd
		.byte $e7,$13,$42,$74,$a8,$e0
		.byte $1b,$59,$9c,$e2,$2c,$7b
		.byte $ce,$27,$84,$e8,$51,$c0
		.byte $36,$b3,$38,$c4,$59,$f6
		.byte $9d,$4e,$09,$d0,$a2,$81
		;---------------------------------------------
		.byte $6d,$67,$70,$88,$b2,$ed
		.byte $3a,$9c,$13,$a0,$44,$02
		.byte $da,$ce,$e0,$11,$64,$da
		.byte $75,$38,$26,$40,$89,$04
		.byte $b4,$9c,$c0,$22,$c8,$b4
		.byte $eb,$71,$4c,$80,$12,$08
		.byte $68,$38,$80,$45,$90,$68
		.byte $d6,$e3,$98,$00,$24,$10

;*************************** EFFECTS' SECTION *******************************************
;---------------- HANDLE ORDERLIST/SEQUENCE-EFFECTS, INPUT:A, DON'T DISTURB X&Y!
SEQ_FX	cmp #$A0		;IF BELOW $A0: TRANSPOSE-FX ($80..$8F:DOWN, $90..$9F:UP)
		bpl chVolFx		;FX ABOVE $A0?
		.if feature.TRANSPOSESUPP_ON
		;SEC - CARRY WAS SET BY 'CMP' JUST BEFORE, AND NEXT -1 WILL COMPENSATE
		sbc #$90-1		;TRANSFORM RANGE $80..$FD TO $F0..$6D
a60b	sta TRANSP2,x	;SET TRANSPOSE-VALUE (2'S COMPLEMENT)
		.fi
		rts

chVolFx	cmp #$B0		;IF VOLUME-FX ($A0..$AF: SET VOLUME TO 0..15 )
		bpl chTmpFx		;FX ABOVE $B0?
		and #$0F
a140	sta SEQVOLU+1	;WILL BE SET TO MAINVOL+1 IN NEXT ROUND (DELAY NEEDED)
		rts
chTmpFx					;TEMPO-SETTING ....;SEC - CARRY WAS SET TO 0 BY 'CMP'
		.if feature.TEMPOPRGSUPP_ON
		sbc #$B0		;SHIFT RANGE $B0..$FD TO $00..$5D
a63b	sta SEQTEMPO,x	;TEMPORARY DELAYED VALUE FOR TRACK-TEMPO SETTING
		.fi
		rts

;------------------------------------------------------------------------------
NOTEFXTBL .byte NPORTAM-INDEXJ1-2,NSYNCON-INDEXJ1-2,NSYNCOF-INDEXJ1-2,NRINGON-INDEXJ1-2
		.byte NRINGOF-INDEXJ1-2,NGATEON-INDEXJ1-2,NGATEOF-INDEXJ1-2,0

NOTE_FX					;NOTE-FX/INSTRUMENT-FX/PATTERN-FX - ALTERATIONS BEFORE CNTPLAY AND SID-WRITING
CHVIBFX cmp #PACKEDMAX+1;$78 ;CHECK VIBRATO-FX IN NOTE-COLUMN - IF SOMEHOW $70-$7F, TREAT AS VIBRATO
		bpl SELNTFX		;IF MORE THAN $70 IT IS NOTE-FX, OTHERWISE TREATED AS VIBRATO
a240	sta VALSTOR+1
a141	jsr VIBAMFX
a142	jmp ENDNOTEFX

SELNTFX tay				;JUMP TO ADDRESS ACCORDINGLY TO PERFORM NOTE-FX
a143	lda NOTEFXTBL-$78,y;INDEX FROM 1ST NOTE-FX (AFTER PACKED-NOP VALUE)
a144	sta INDEXJ1+1
a145	lda WFGHOST,x	;PRELOAD WAVEFORM-REGISTER
		clc				;ENSURE JUMP INSTEAD OF CONDITIONAL BRANCHING
INDEXJ1 bcc *+2			;THIS SMALLFX-BRANCH SECTION MUST FIT IN $7F BYTES

NPORTAM ldy #$FF		;PRE-SIGN NOTE-PORTAMENTO FOR 'TICK2'
		lda #DEFAULTPORTA;AN AVERAGE SPEED-VALUE FOR THE TONE-PORTAMENTO
a146	jsr SETSLID		;SET SLIDE-TYPE AND SLIDE-SPEED
a147	jmp ENDNOTEFX

NSYNCON ora #%00000010	;SET SYNC BIT ;SYNCONFX
		bne WRWFORM
NSYNCOF and #%11111101	;RESET SYNC BIT ;SYNCOFFX
a149	jmp WRWFORM
NRINGON ora #%00000100	;SET RING BIT ;RINGONFX
		bne WRWFORM
NRINGOF and #%11111011	;RESET RING BIT ;RINGOFFX
WRWFORM sta WFGHOST,x
a151	jmp ENDNOTEFX

NGATEON lda #$FF		;GATEONFX ;$7D ;GATE-ON?  ;NOTE-FX - INPUT:ACCU
a152	sta PTNGATE,x
a227	lda WFGHOST,x
		ora #1
		bne WRWFORM

NGATEOF					;GATEOFFX ;$7E ;GATE-OFF?
		.if feature.GATEOFFPTR_ON
		ldy #$0C		;SET TABLEPOSITIONS TO GATE-OFF POINTERS
		lda (PLAYERZP),y;GATE-OFF POINTER FOR WF-ARP. TABLE
		bne SETGOFF		;IF WFARP-GATEOFF NONZERO, SET IT
		.fi
		lda #$FE		;NORMAL GATE-OFF GATE-BIT OFF 'AND'-ER
a154	sta PTNGATE,x
a155	and WFGHOST,x
a156	sta WFGHOST,x
		.if feature.GATEOFFPTR_ON
a64b	jmp chPWgof

SETGOFF sta WFTPOS,x	;RESET ARP-SPEED COUNTER?
chPWgof	ldy #$0D
		lda (PLAYERZP),y;GATE-OFF POINTER FOR PULSEWIDTH-TABLE
		beq a66b
a65b	sta PWTPOS,x
a66b	cpx FLTCTRL+1	;CHECK IF THIS IS FILTER-CONTROLLER TRACK
		bne endGoff		;IF NOT FILTER-CONTROLLER TRACK, DON'T MODIFY ANYTHING
		iny				;$0E
		lda (PLAYERZP),y;GATE-OFF POINTER FOR FILTER-TABLE
		beq endGoff
a67b	sta FLTPOSI+1
endGoff
		.fi
ENDNOTEFX

;---------------------------------------------------------------------
INSPTFX					;ENTRY POINT FOR INST.&PATTERN-FX TOGETHER (SKIPPED NOTE-FX)
INST_FX lda ACTIFX,x	;CHECK INST/FX COLUMN	;PRIO3
		cmp #$40
		bmi PATT_FX		;IF INSTRUMENT or NOP
a157	jsr SMALPFX		;IF INSTRUMENT-FX

;---------------------------------------------------------------------
PATT_FX lda ACTFX2,x	;PRIO2
		beq RETURFX		;IF NOP - MAYBE NOT NEEDED TO DISTINGUISH, TAKEN FROM FX-TABLE
		cmp #$20		;LOWER LIMIT OF SMALL-FX
		bcs SMALPFX

;------------------------------------------
BIGPTFX asl				;WE'RE READING WORDS
		tay
a158	lda BIGFXTABLE-2,y;NO FX 0, SO CHECKING FX1 AT POSITION 0
a159	sta INDEXJP+1
a160	lda BIGFXTABLE-1,y;NO FX 0, SO CHECKING FX1 AT POSITION 0
a161	sta INDEXJP+2
a162	lda ACTVAL,x	;PRELOAD FX VALUE
INDEXJP jmp RETURFX		;SELF-WRITTEN JUMP-ADDRESS FOR BIGFX

RETURFX rts				;FOR SAFETY AND NOP

;-----------------------SOME FX-VALUE CONVERSION ROUTINES------
SETINBL lda (PLAYERZP),y;INSTRUMENT-BYTE
SETNIBL and #$F0		;SET LOW NIBBLE AT ACCU
a163	ora VALSTOR+1
		rts

SETINBH lda (PLAYERZP),y;INSTRUMENT-BYTE
SETNIBH and #$0F		;SET HIGH NIBBLE AT ACCU
a164	sta MERGEST+1
VALSTOR lda #0			;SELF-WRITTEN
		asl
		asl
		asl
		asl				;x16
MERGEST ora #0			;SELF-WRITTEN
		rts

MULTI3C					;MULTIPLY ACCU WITH 3, RESULT IS STORED INTO ACCU
a211	sta MUL3TMP+1
		asl
MUL3TMP adc #0			;SELF-WRITTEN
		rts

;-------------------------------SMALL-FX---------------------------------------
SMALLFXTBL .byte SMALFX2-INDEXJ2-2,SMALFX3-INDEXJ2-2;THIS TABLE IS FOR INSTRUMENT-FX AND SMALL PATTERN-FX
		.byte SMALFX4-INDEXJ2-2,SMALFX5-INDEXJ2-2,SMALFX6-INDEXJ2-2,SMALFX7-INDEXJ2-2
		.byte SMALFX8-INDEXJ2-2,SMALFX9-INDEXJ2-2,SMALFXA-INDEXJ2-2,SMALFXB-INDEXJ2-2
		.byte SMALFXC-INDEXJ2-2,SMALFXD-INDEXJ2-2,SMALFXE-INDEXJ2-2,SMALFXF-INDEXJ2-2

SMALPFX pha
		lsr				;GET SMALLFX-TYPE -
		lsr
		lsr
		lsr				;...DIVIDE BY 16
		tay
a165	lda SMALLFXTBL-2,y;NOTHING BELOW 2 FOR SMALLFX
a166	sta INDEXJ2+1
		pla
		and #$0F		;ACCU=EFFECT-VALUE (ARGUMENT)
a167	sta VALSTOR+1	;STORE FX-VALUE NIBBLE FOR LATER USE
		clc				;ENSURE JUMP INSTEAD OF CONDITIONAL BRANCHING
INDEXJ2 bcc *+2			;THIS SMALLFX-BRANCH SECTION MUST FIT IN $7F BYTES
ENDSMFX rts				;FOR SAFETY AND RETURN FROM NOP

SMALFX2					;SET 'ATTACK' NIBBLE OF ADSR  - (NO SMALLFX-1, AS $00..$1F VALUES ARE BIGFX)
		.if feature.ALLGHOSTREGS_ON==0
		ldy #3			;AD - INDEX
a168	jsr SETINBH		;GET&SET INSTRUMENT-DATA HIGH-NIBBLE WITH ACCU
		.else
a121b	lda ADGHOST,x
a168	jsr SETNIBH
		.fi
a169	jmp WRITEAD

SMALFX3					;SET 'DECAY' NIBBLE OF ADSR
		.if feature.ALLGHOSTREGS_ON==0
		ldy #3			;AD - INDEX
a170	jsr SETINBL		;GET&SET INSTRUMENT-DATA LOW-NIBBLE WITH ACCU
WRITEAD sta SIDBASE+5,x
		.else
a122b	lda ADGHOST,x
a170	jsr SETNIBL
WRITEAD	sta ADGHOST,x
		.fi
		rts

SMALFX4					;'4' = SID-REGISTER4 - ADJUST WAVEFORM
a171	lda WFGHOST,x
a172	jsr SETNIBH
WRITEWF sta WFGHOST,x
		rts

SMALFX5					;SET 'SUSTAIN' NIBBLE OF ADSR (NOTE-VOLUME)
		.if feature.ALLGHOSTREGS_ON==0
		ldy #4			;SR - INDEX
a173	jsr SETINBH
		.else
a123b	lda SRGHOST,x
a173	jsr SETNIBH
		.fi
a174	jmp WRITESR

SMALFX6					;'6' = SID-REGISTER6/RELEASE - SET 'RELEASE' NIBBLE OF ADSR
		.if feature.ALLGHOSTREGS_ON==0
		ldy #4			;SR - INDEX
a175	jsr SETINBL		;GET&SET INSTRUMENT-DATA LOW-NIBBLE WITH ACCU
WRITESR sta SIDBASE+6,x
		.else
a124b	lda SRGHOST,x
a175	jsr SETNIBL
WRITESR	sta SRGHOST,x
		.fi
		rts

SMALFX7					;'7' = SET 'MAJ7 OR OTHER CHORD' FOR INSTRUMENT (OTHER THAN THE DEFAULT ASSIGNED CHORD)
		.if feature.CHORDSUPPORT_ON
a68b	sta ACTCHORD,x
		tay
p_chdp4 lda CHDPTRLO,y	;GET CHORD-BASEPOINTER
a69b	sta CHORDPOS,x
		.fi
		rts

SMALFX8					;SET VIBRATO AMPLITUDE
VIBAMFX ldy #5
a239	jsr SETINBH
a176	jmp BIGFX08

FORCVIB ldy #0			;RESET SLIDE/VIBRATO - SET IT TO VIBRATO BY DEFAULT
		lda (PLAYERZP),y;READ VIBRATO-TYPE FROM INSTRUMENT
FORCVI2 and #$30
a186	sta SLIDEVIB,x
		rts

SMALFX9					;SET VIBRATO FREQUENCY
		asl				;ASL, BIT 1 IS ALWAYS 0, SO IT CAN BE CLIPPED INTO 2 EQUAL TIMEFRAMES FOR SLIDE UP/DOWN
a209	sta VIBFREQU,x
		rts

SMALFXA					;'A' = ADJUST MAIN VOLUME
a177	sta MAINVOL+1
a187	sta SEQVOLU+1
		rts

SMALFXB					;'B' = BAND-NIBBLE OF FILTER (LOW/MID/HI/3OFF)
		asl
		asl
		asl
		asl				;x16
a178	sta FLTBAND+1
		rts
;
SMALFXC					;'C' = CHORD-SPEED AND ARPEGGIO-SPEED SETTING
		.if feature.ARPSPEEDSUPP_ON
a70b	sta ARPSPED,x
		lda #$FF		;CAUSE AN INSTANT START WITH NEW COUNTER 
a71b	sta ARPSCNT,x	;(ARPSCNT,x is also used to determine new note 1st frame for multispeed)
		.fi
		rts

SMALFXD asl			;x8 ;'D' = DETUNE ACTUAL NOTE
		asl
		asl
a179	jmp SETDETU

SMALFXE					;'E' = ENABLE/DISABLE TEST-BIT, RING-BIT, SYNC-BIT, GATE-BIT
a180	lda WFGHOST,x
a181	jsr SETNIBL		;SET LOW NIBBLE
a182	jmp WRITEWF

		.cerror *>INDEXJ2+$7F,"SOME OF LAST FX ARE OUT OF MAX BRANCH RANGE!!!"
SMALFXF					;'F' = FILTER RESONANCE (STRENGTH) NIBBLE SETTING
		asl
		asl
		asl
		asl				;x16
a183	sta RESONIB+1
		rts

;==========================================================================================
;IN COMING FX SECTION THE EFFECT-SUBROUTINES CAN BE SET IN ORDER OF STATISTICAL USE-RATE
;IF THE LEAST IMPORTANT EFFECTS ARE NOT USED IN TUNE, THE CODE CAN BE WIPED OUT BY
;SID-MAKER APP. PLAYER-CODE SIZE-REDUCTION COULD BE GAINED THAT WAY....
;------------------------------------------------------------------------------------------
;-----------------------------------------------------BIG-FX JUMP ADDRESSES---------------
BIGFXTABLE .word BIGFX01,BIGFX02,BIGFX03,BIGFX04,BIGFX05,BIGFX06,BIGFX07
		.word BIGFX08,BIGFX09,BIGFX0A,BIGFX0B,BIGFX0C,BIGFX0D,BIGFX0E,BIGFX0F
		.word BIGFX10,BIGFX11,BIGFX12,BIGFX13,BIGFX14,BIGFX15,BIGFX16,BIGFX17
		.word BIGFX18,BIGFX19,BIGFX1A,BIGFX1B,BIGFX1C,BIGFX1D,BIGFX1E,BIGFX1F
ENDBIGFXTB ;Big-FX table should be of the same size with the same positions in every players

;-------------------------------BIGFX------------------------------------------

BIGFX01					;PITCH SLIDE UP - FX-NUMBER IS THE SAME AS GOATTRACKER'S
		ldy #$81		;THIS VALUE CAUSES UP-SLIDE
		bne SETSLID

BIGFX02					;PITCH SLIDE DOWN - FX-NUMBER IS THE SAME AS GOATTRACKER'S
		ldy #$82		;THIS VALUE CAUSES DOWN-SLIDE
SETSLID pha
		tya
a185	sta SLIDEVIB,x	;CAUSE SLIDE INSTEAD OF VIBRATO
		pla				;THEN CALCULATE SLIDE-AMOUNT BASED ON NOTE-PITCH
a220	jmp SETFMOD

BIGFX03					;TONE PORTAMENTO - FX-NUMBER IS THE SAME AS GOATTRACKER'S
		ldy #$83
		bne SETSLID

BIGFX04	= WRITEWF		;'4' = 4TH REGISTER WAVEFORM SIMPLE SETTING
;a189	jmp WRITEWF

BIGFX05 = WRITEAD		;'5' = 5TH SID-REGISTER SETTING - ATTACK AND DECAY

BIGFX06 = WRITESR		;'6' = 6TH SID-REGISTER SETTING - SUSTAIN AND RELEASE

BIGFX07 = SMALFX7		;'7' = SELECT (MAJOR-7 OR ANY OTHER CHORD) FOR CURRENT INSTRUMENT

BIGFX08					;'8' = SET VIBRATO FREQUENCY AND AMPLITUDE (NUMBER '8' IS A SIN/COS LISSAJOUS)
		pha
a192	jsr FORCVIB		;FORCE VIBRATO INSTEAD OF SLIDE, READ TYPE FROM INSTRUMENT
		pla
a193	jmp SETVIBR		;SET VIBRATO-AMPLITUDE AND FREQUENCY AND FREQ.COUNTER

BIGFX09 ;GO TO WAVEFORM-ARPEGGIO TABLE POSITION
a190	jsr MULTI3C		;MULTIPLY ACCU BY 3, STORE RESULT IN ACCU
		adc #WFTABLEPOS
a191	sta WFTPOS,x
		rts

BIGFX0A					;'A' = ADJUST INST.PARAMETER-A - PULSEWIDTH-PROGRAM TABLEPOINTER
a194	jsr MULTI3C
		ldy #$0A
		adc (PLAYERZP),y;PULSEWIDTH-PROGRAM POSITION INDEX
a195	sta PWTPOS,x
		rts

BIGFX0B					;'B' = INSTRUMENT-PARAMETER 'B' - SET FILTER-PROGRAM TABLEPOINTER
a196	jsr MULTI3C
		ldy #$0B
		adc (PLAYERZP),y;PULSEWIDTH-PROGRAM POSITION INDEX
a197	sta FLTPOSI+1	;,X
		rts

BIGFX0C = SMALFXC		;'C' = CHORDSPEED/ARPSPEED (MAX $3F)

BIGFX0D					;'D' = FINE-DETUNE ACTUAL TRACK WITH GIVEN AMOUNT
SETDETU sta DETUNER,x	;adc FREQLO,x
;a198	sta FREQLO,x	;HANDLE PITCH-DETUNING (DELAYED VIBRATO STILL APPLICABLE)
;		bcc retDetu
;a199	inc FREQHI,x
retDetu	rts

BIGFX0E					;SIMPLE PULSEWIDTH-SETTING - INSTRUMENT TABLE CAN OVERRIDE IT
		and #$0F
a200	sta PWHIGHO,x
		rts

BIGFX0F					;'F' = FILTER-CUTOFF-HIGH BYTE SETTING
a238	sta CTFHGHO+1
		rts

;------------------------------------------------------------------
BIGFX10					;SET MAIN SINGLETEMPO
		ora #$80		;SINGLE TEMPO, NOT CONTINUED TO FUNKTEMPO OR TEMPOPROGRAM
MAINTMP					;ENTRY POINT USED BY OTHER SPEED-SETTERS
p_tmpt6 sta TEMPOTBL+0	;1ST SPEED VALUE
		lda #0			;RESET TRACK-TEMPOPOINTERS TO 1ST TEMPOTABLE-POSITION
MAINTM2
		.if feature.TEMPOPRGSUPP_ON
a202	sta TMPPOS+0
a203	sta TMPPOS+7
a204	sta TMPPOS+2*7
a205	sta TMPPTR+0
a206	sta TMPPTR+7
a207	sta TMPPTR+2*7
		.fi
		rts

BIGFX11					;SET MAIN FUNKTEMPO SPEED 1 AND SPEED 2
		.if feature.TEMPOPRGSUPP_ON
		pha
		and #$0F		;SET 2ND FUNKTEMPO
		ora #$80		;THE TEMPOPROGRA STOPS HERE
p_tmpt7 sta TEMPOTBL+1
		pla
		lsr
		lsr
		lsr
		lsr				;/16
		bpl MAINTMP		;SET 1ST FUNKTEMPO, RESET TABLEPOINTERS
		.fi

BIGFX12					;SET MAIN TEMPOPROGRAM
		.if feature.TEMPOPRGSUPP_ON
		beq RTBIGFX		;NO TEMPOPROGRAM 0
		tay
p_tmpp1 lda TEMPTRLO,y
a73b	jmp MAINTM2
		.fi

BIGFX13					;SET TRACK SINGLETEMPO
		.if feature.TEMPOPRGSUPP_ON
TRAKTMP ora #$80		;MAKE THE TEMPOPROGRAM STOP HERE
TRKTMP2 ldy TRKTMPOS,x	;GET POSITION OF TRACKTEMPO IN TEMPOTABLE (2,4,6)
p_tmpt8 sta TEMPOTBL,y
		tya
TRKTMP3 sta TMPPTR,x
a74b	sta TMPPOS,x
		rts
		.fi

BIGFX14					;SET TRACK FUNKTEMPO SPEED 1 AND SPEED 2
		.if feature.TEMPOPRGSUPP_ON
		pha
		lsr
		lsr
		lsr
		lsr				;/16
a75b	jsr TRKTMP2 ;Y is calculated inside this routine
		pla
		and #$0F		;SET 2ND FUNKTEMPO
		ora #$80
p_tmpt9 sta TEMPOTBL+1,y;SET 2ND FUNKTEMPO (Y CALCULATED IN SUBROUTINE PREVIOUSLY)
		rts
		.fi
;
BIGFX15					;SET TRACK TEMPOPROGRAM
		.if feature.TEMPOPRGSUPP_ON
		beq RTBIGFX
		tay
p_tmpp2 lda TEMPTRLO,y
a76b	jmp TRKTMP3
		.else
		rts
		.fi

BIGFX16	= FORCVI2		;SELECT VIBRATO-TYPE (USEFUL WHEN NEED INCREASING VIBRATO OCCASIONALLY)

BIGFX17					;?...LEFT FOR EXPANSION
BIGFX18					;?...LEFT FOR EXPANSION
BIGFX19					;?...LEFT FOR EXPANSION
BIGFX1A					;?...LEFT FOR EXPANSION
BIGFX1B					;?...LEFT FOR EXPANSION

BIGFX1C
a201	sta FLSHIFT+1	;SHIFTS OVERALL FILTER WITH THIS AMOUNT (80..$FF:NEGATIVE, 00..$70:POSITIVE)
		rts

BIGFX1D					;'D' = DELAY TRACK BY $00..$FE FRAMES
		.if feature.DELAYSUPPORT_ON
DELAYER ldy TRDELAY,x
		beq a80b		;$00 SIGNS ENDING OF DELAYER-LOOP
						;PREPARINGING THE NEXT POSSIBLE DELAY
						;FINISH DELAY BY NOT DISTURBING SPDCNT,X

		iny				;$FF SIGNS BEGINNING OF DELAYER LOOP
		bne keepDly
a78b	sta TRDELAY,x	;IF STARTING DELAY, WRITE ACCU TO DELAY-COUNTER
keepDly	lda #2			;THIS STOPS THE TRACK FOR A WHILE
a79b	sta SPDCNT,x
a80b	dec TRDELAY,x	;COUNTING DELAY
		rts
		.fi

BIGFX1E					;DELAY ACTUAL NOTE BY $00..$FF FRAMES
		.if feature.DELAYSUPPORT_ON
a81b	ldy TRDELAY,x
		bne a84b		;$00 SIGNS ENDING OF DELAYER-LOOP
		clc
a82b	adc SPDCNT,x
a83b	sta SPDCNT,x	;COMPENSATE CAUSED DELAY BY INCREASING SPEED-COUNTER
a84b	jmp DELAYER
		.else
		rts
		.fi

BIGFX1F					;?...LEFT FOR EXPANSION - filt-external on/off (if ON, reduces SID-noise)
		.if feature.FILT_CTRL_FX_ON
		pha
		and #$0F
a107b	sta FSWITCH+1 ;now it's direct setting, resonance nybble can be overwritten by program, filt.ex. stays intact after set
		pla
		and #$F0
a108b	sta RESONIB+1
		.fi

RTBIGFX rts

player_top
.here			;restore physical address
playercode_end	;copiers will know where it ends

;==========================================reloc-table=================================================
;this table contains the absolute-addresses that need to be relocated in player code (SIDBASE is exception).
;whenever any absolute-addressing command is added to player, this needs to be adjusted

		.if ( COMPILEDAPP==2 )
		.if (ATTACH_RELOCTABLE_ON)

reloctable

		.word         inisub, playsub, mulpsub, volusub
		.word MULTIPW,MULTIFI,NONEWNO
		.word SWONFLT,SWOFFLT,LEGATOO,INDEXJP
		.word SETDETU,SKIPWFT,SEQFXL2,SETFPOS,INSTVIB
		.word SETSEQB
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word INIPTN,         TICK_0
		.word SUBFREQ,ADDFREQ,WRPITCH
		.word STORVHI,WRWFGHO,WRWFORM,WRITEWF
		.word SEWFARP,PTN_SEQ,RDWFROW
		.word SETPWID,TICK_1,SETPNUM,HARDRST,COLUMN1
		.word PORTAME,TARGETN,INST_FX,SEL_INS,CNTPLAY
		.word NEWNOTE,PATT_FX,PORTADN,PORTAUP,NORMVIB
		.word DOVIBRA, SEQFXLO
		;self-written instruction,should always be non-zeropage absolute-addressing with 2-byte address
		.word ptncode ;ldy SEQPOS,x
		.fi

		;addresses of rest of absolute-addressing commands
		.word a1,  a3,a4,a5,a6, a7, a8,a9,a10
		.word a11,a12,a13,a14,a15,               a20
		.word     a22
		.word                         a37,a38,a40
		.word a41,        a44,a45,        a48,a49,a50
		.word a51,                    a57,        a60
		.word a61,a62,a63,a64,            a68
		.word a71,a72,a73,a74,    a76,    a78,a79
		.word     a82,    a84,a85,    a87 
		.word                 a95

		.word a102,a103,a104,a105,a107,a108,a109,a110
		.word      a112
		.word                                         a129
		.word           a133,     a135,          a138,a139,a140
		.word a141,a142,a143,a144,     a146,a147,a149
		.word a151,               a157,a158,a159,a160
		.word a161,     a163,a164,a165,a166,a167,a168,a169,a170
		.word      a172,a173,a174,a175,a176,a177,a178,a179 
		.word a181,a182,a183,          a187,     a190
		.word      a192,a193,a194,     a196,a197,          a200
		.word a201                                        ;,a210
		.word a211,a212,     a214,     a216,               a220
		.word                     a225,a226,               a230
		.word a231, a232,a233,a234,a235, a238 , a239 , a240
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word a77,a83,a92,a98,a134 ;FREQLO,x
		.word a80,a93,a99,a136,a137 ;FREQHI,x
		.word a116,a117,a123,a126 ;PWLOGHO,x
		.word a115,a118,a122,a200 ;PWHIGHO,x
		.word a222,a223,a65,a128,a145,a227,a155,a156,a171,a180 ;WFGHOST,x
		.word a221,a67,a152,a154 ;PTNGATE,x
		.word a113,a114,a125 ;PWEEPCNT,x
		.word a16,a17,a18,a19,a36 ;SPDCNT,x
		.word a42, a237 ;SEQPOS,x
		.word a25,a34,a43 ;PTNPOS,x
		.word a66,a127,a131,a191 ;WFTPOS,x
		.word a59,a121,a124,a195 ;PWTPOS,x
		.word a26,a28 ;ACTNOT,x
		.word a52,a132 ;DPITCH,x
		.word a23,a29,a31,a219,a46,a54 ;ACTIFX,x
		.word a229,a47 ;ACTINS,x
		.word a24,a32,a53 ;ACTFX2,x
		.word a33,a162 ;ACTVAL,x
		.word a224,a218,a56,a58,a75,a186,a185 ;SLIDEVIB,x
		.word a91,a97,a213,a215 ;FREQMODL,x
		.word a55,a81,a94,a96,a100,a217 ;FREQMODH,x
		.word a86,a69 ;VIDELCNT,x
		.word a88,a90,a208,a209 ;VIBFREQU,x
		.word a89,a70 ;VIBRACNT,x
		;Commands that cannot be put into 'zeropage addressing' due to platform (6510) limitations:
		.word a2 ;sta VARIABLES,y
		.word a228 ;ldy ACTINS,x
		.word a236, a23b,a47b ;ARPSCNT,x - brought to help multispeed determine 1st frame of new note
		.fi

		.word a15b ;used after hard-restart checking

		.if feature.FILTKBTRACK_ON
		.word a1b,a37b, a131b
		.fi

		.if feature.DELAYSUPPORT_ON
		.word a2b
		.fi

		.if feature.FILTKBTRACK_ON
		.word a3b,   a5b
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word a4b
		.fi
		.fi

		.if feature.TEMPOPRGSUPP_ON
		 .word TRKTMP2
		 .word             a61b,a62b,a63b,a73b,    a75b,a76b, a106b
		 .if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		 .word TRKTMP3
		 .word a6b,a9b,a10b,a74b
		 .word a205,a206,a207 ;TMPPTR,x related
		 .word a202,a203,a204 ;TMPPOS,x related
		 .fi
		.fi

		.if PACKEDNOPSUPP_ON
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word PACKNOP,a11b,a12b,a19b
		.fi
		.fi

		.if feature.FASTSPEEDBIND_ON
		 .word a204b
		 .if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		 .word CHKTMP1,CHKTMP2
		 .fi
		.fi

		.if feature.HARDRESTYPES_ON
		;.word        ;a16b,a17b,a18b
		 .if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		  .word a13b, a14b
		  .if feature.ALLGHOSTREGS_ON
           .word a120b
		  .fi
		 .fi
		.fi

		.if feature.FRAME1SWITCH_ON ;CHECK IF WAVEFORM1 SWITCH ENABLED
		 .word a97b 
		 .if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		  .word a96b
		  .if feature.ALLGHOSTREGS_ON
		   .word a98b
		  .fi
		 .fi
		.fi

		.if (feature.PWRESETSW_ON+feature.FILTRESETSW_ON)
		.word CHKNOTE
		.fi

		.if feature.TRANSPOSESUPP_ON
		.word a21,  a60b, a104b
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word a105b,a20b
		.fi
		.fi

		.if feature.PWRESETSW_ON
		.word a21b
		.fi

		.if feature.FILTRESETSW_ON
		.word a22b
		.fi

		.if feature.ARPSPEEDSUPP_ON
		;.word       
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word    a24b,a45b,a46b,    a48b,a71b,        a70b    
		.fi
		.fi

		.if feature.CHORDSUPPORT_ON
		.word         a52b,                        a58b
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word LOOPCHD,DOCHORD
		.word a56b,a57b,a25b,a54b,a68b, a26b,a53b,a55b,a59b,a69b
		.fi
		.fi

		.if feature.VIBRATOTYPES_ON 
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word INCVIBR,a27b,a28b,a29b,a30b
		.fi
		.fi

		.if feature.DETUNESUPPORT_ON
		.word a202b,a203b
		.fi

		.if feature.FINEFILTSWEEP_ON
		.word a31b,a32b,a33b,a34b,a35b,a36b
		.fi

		.if feature.PWKEYBTRACK_ON
		.word               a41b,a42b
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word a38b,a39b,a40b,a43b
		.fi
		.else
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word a44b
		.fi
		.fi

		.if feature.GATEOFFPTR_ON
		.word a64b,     a66b,a67b
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word SETGOFF,a65b
		.fi
		.fi

		.if feature.DELAYSUPPORT_ON
		.word DELAYER
		.word a78b,    a80b,a81b,       a84b
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word a79b,a82b,a83b
		.fi
		.fi

		.if feature.SUBTUNEJUMP_ON
		.word a93b,a94b     ;,a89b,     a91b,a92b
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		;.word a85b,a86b,a87b,a88b
		.fi
		.fi

		.if feature.CALCVIBRATO_ON
				;word a99b,a100b,a101b
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word a95b
		.fi
		.fi

		.if feature.PORTAVIBRA_ON=1
		.word a200b,a201b
		.fi

		.if feature.FILT_CTRL_FX_ON
		.word a107b,a108b,a109b
		.fi
		
		.if feature.ALLGHOSTREGS_ON
		.if (PLAYERZP_VAR==0) ;don't relocate absolute variable-addressing at zeropage
		.word WRITEAD,WRITESR
		.word a110b,a111b,a112b,a113b,a114b,a115b,a116b
		.word a117b,a118b,a119b,      a121b,a122b,a123b
		.word a124b,a125b,a126b,a127b,a128b,a129b,a130b
		.fi
		.fi


;absolute-musicdata-addressing instructions which are modified by the player only (not really important to relocate, set at tune-init)
		.word p_seqt1, p_seqt2, p_seqt3

;-----------------------------------------------------------------------------------
;addresses of absolute-instructions which point to music data (set to music-data in 'setplayer' even before relocation)
DataPtr	.word p_subt1, p_subt2, p_subt3, p_subt4
		.word p_ptnl1, p_ptnl2,  p_ptnh1, p_ptnh2
		.word p_insl1, p_insl3, p_insl4, p_insl5
		.word p_insh1, p_insh3, p_insh4, p_insh5
		.if feature.HARDRESTYPES_ON 
		 .word p_insl2, p_insh2
		.fi
		
		.word p_tmpt1
		
		.word p_tmpt4, p_tmpt5, p_tmpt6
		
		.if feature.FASTSPEEDBIND_ON
		 .word p_tmpt2, p_tmpt3
		.fi
		
 		.if feature.TEMPOPRGSUPP_ON
		 .word p_tmpt7, p_tmpt8, p_tmpt9  
         .word p_tmpp1, p_tmpp2
		.fi
		
		.if feature.CHORDSUPPORT_ON
		 .word p_chdt1, p_chdt2
		 .word p_chdp1, p_chdp2, p_chdp3, p_chdp4
		.fi
DataPtr_end


		.word 0			;signs end of relocation data
reloctable_end

;==============================================================================
;this table tells which zeropage-pointer to load to operands of instructions given in 'DataPtr' above
;the number after means what value to add to (or substract from) the pointer
PtrValu	.byte subtuneadd,0, subtuneadd,0, subtuneadd,0, subtuneadd,1 ;p_subt1, p_subt2, p_subt3, p_subt4
		.byte ptnptloadd,0, ptnptloadd,0, ptnpthiadd,0, ptnpthiadd,0 ;p_ptnl1, p_ptnl2,  p_ptnh1, p_ptnh2
		.byte insptloadd,0, insptloadd,0, insptloadd,0, insptloadd,0 ;p_insl1, p_insl3, p_insl4, p_insl5
		.byte inspthiadd,0, inspthiadd,0, inspthiadd,0, inspthiadd,0 ;p_insh1, p_insh3, p_insh4, p_insh5
		.if feature.HARDRESTYPES_ON
		 .byte insptloadd,0, inspthiadd,0 ;p_insl2, p_insh2
		.fi
		
		.if feature.TEMPOPRGSUPP_ON
		 .byte tempotbadd,$FF ;p_tmpt1; $FF means 'substract 1'
		.else
		 .byte tempotbadd,0 ;p_tmpt1
		.fi
		
		.byte tempotbadd,0, tempotbadd,1, tempotbadd,0 ;p_tmpt4, p_tmpt5, p_tmpt6
		
		.if feature.FASTSPEEDBIND_ON
		 .byte tempotbadd,0, tempotbadd,0 ;p_tmpt2, p_tmpt3
		.fi
		
 		.if feature.TEMPOPRGSUPP_ON
		 .byte tempotbadd,1, tempotbadd,0, tempotbadd,1 ;p_tmpt7, p_tmpt8, p_tmpt9
		 .byte tempoptadd,0, tempoptadd,0 ;p_tmpp1, p_tmpp2
		.fi
		
		.if feature.CHORDSUPPORT_ON
		 .byte chordtbadd,0, chordtbadd,0 ;p_chdt1, p_chdt2
		 .byte chordptadd,0, chordptadd,0, chordptadd,0, chordptadd,0 ;p_chdp1, p_chdp2, p_chdp3, p_chdp4
		.fi
PtrValu_end
		.byte 0			;signs end of player-setter data 


		.fi
		.fi


;******************************************************************************
; vim: sw=4 ts=4 syntax=asm:
