;========================== startup-menu (select playertype/PAL-NTSC/freq.table/help) ========================
;at program-startup it is in pattern-area, then will be overwritten at pattern-initialization at startup)

stmenuXpos=0
stmenuYpos=7
mnptpos=16 ;x-position of menupoints
tickColumn1=12
tickColumn2=39
tickcol=9  ;ticks' colour
bordcol=6  ;menu-border colour
featcol=11 ;feature-name colour
fademin=8  ;menupoint-colour position in fade-list
fademax=15 ;selected menupoint-colour in fade-list
sfadespd=2 ;menupoint-fadeout speed
fadespd=2  ;border-fadeout speed


STARTUPMENU .block ;called from the basic starter
doit	sei
		jsr commonsubs.PALorNTSC	;detect if PAL or NTSC machine, store 0/1 result at a memory location 'PALNTSC'
		lda PALNTSC
		bne +
		ldy #3
-		lda NTSCtx,y
		sta machitx,y
		dey
		bpl -
+

		lda #0
		sta $d011 ;hide remaining graphics after splash-screen-depacking
		sta $d015
		sta $d021
		;sta $d020 ;will be set by effect
		lda #3
		sta $dd00
		lda #$17
		sta $d018
		ldy #0
-		lda #$20
		sta lowvidram,y
		sta lowvidram+$100,y
		sta lowvidram+$200,y
		sta lowvidram+$300,y
		lda #3
		sta COLRPOS,y
		sta COLRPOS+$100,y
		sta COLRPOS+$200,y
		sta COLRPOS+$300,y
		iny
		bne -
		lda #$1b
		sta $d011

jsr dismenu		;display menu (static part)

;-------------------------------
		lda $d020		;init fader
		and #$0f
		tay
		lda ColBright,y
		tay
		sta colcnt

ScrLoop	lda $d011
		bmi ScrLoop
		lda #$20
		cmp $d012
		bne *-3

		dec fadespcnt
		bne KeyBdCh
		lda #fadespd
		sta fadespcnt
		ldy colcnt		;fade to black
		beq +
		dey
+		sty colcnt
		lda BrightCol,y
		sta $d020

KeyBdCh	jsr keyhandler.shcbget		;Shift/C= key status
		lda #$FE
		sta $dc00
		lda $dc01
chCurDn	cmp #($ff-$80)
		bne chRetur
		lda shiftsi
		beq incsele
decsele	lda norepeat
		bne endKbCh
		jsr resetsfade
		dec selection
		bpl newmnpt
		lda #3
		sta selection
newmnpt	lda #0
		sta scrollcnt
		jsr CopyFeat ;copy features to the main editor code
		jmp endKbCh
incsele	lda norepeat
		bne endKbCh
		jsr resetsfade
		ldy selection
		iny
		cpy #4
		bmi +
		ldy #0
+		sty selection
		jmp newmnpt

chRetur	cmp #($ff-2)
		beq SetPlayer	;exit loop if return pressed

nokeypr	lda #$ff
		sta norepeat	;causes 0 in 'norepeat'
endKbCh	inc norepeat

Display	jsr ColMenuPt	;colourize menu-points based on selection
		jsr playertxt	;display player-description
		jsr DispFeat	;display feature-signals

		lda #($d2-1)-8
		jsr doSkewy
		lda #($d2-1)
		jsr doSkewy

		jmp ScrLoop


;-----------------------------
SetPlayer
		lda #0
		sta $d011
		sta $d020

		lda selection
		beq ChkFreqTb ;normal player? don't modify it...
		jsr altplayers.CopyPlayer ;copy the selected player into place of the default

AdjustEditor ;adjust some editor-addressing to fully adopt the new player
		lda selection
		beq ChkFreqTb
		cmp #1
		bne + ;medium?
		lda mediumPlayer.aEXPTBH+0
		ldx mediumPlayer.aEXPTBH+1
		jmp wriPtPt
+		cmp #2
		bne + ;light?
		lda lightPlayer.aEXPTBH+0
		ldx lightPlayer.aEXPTBH+1
		jmp wriPtPt
+		lda extraPlayer.aEXPTBH+0
		ldx extraPlayer.aEXPTBH+1
wriPtPt	sta playadapter.dispScope.p_EXPT2+1
		stx playadapter.dispScope.p_EXPT2+2
		sta upbordisp.p_EXPT3+1
		stx upbordisp.p_EXPT3+2
		clc
		adc #8 ;+8
		bcc +
		inx
+		sta playadapter.dispScope.p_EXPT1+1
		stx playadapter.dispScope.p_EXPT1+2
		clc
		adc #1 ;+9
		bcc +
		inx
+		sta upbordisp.p_EXPT4+1
		stx upbordisp.p_EXPT4+2

ChkFreqTb
		lda selection
		jsr altplayers.SetFreqTb ;if needed, change to NTSC table

		rts ;continue to the editor which is now set


;--------------------------------------------------------------
.include "altplayers.inc" ;this file contains the alternative players that can overwrite the default



;---------------------------------subroutines-----------------------------------

dismenu	ldy #39
-		lda titletx,y
		sta lowvidram+1*40,y
		lda #1
		sta COLRPOS+1*40,y
		lda #$64
		sta lowvidram,y
		lda #$63
		sta lowvidram+2*40,y
		lda selectx,y
		jsr convASCII
		sta lowvidram+4*40,y
		lda machitx,y
		jsr convASCII
		sta lowvidram+24*40,y
		lda #11
		sta COLRPOS+24*40,y
		dey
		bpl -

		lda #<menugraph
		ldx #>menugraph
		sta datzptr+0
		stx datzptr+1
		jsr setmrow1 ;set screen pointers to menu and zpvari2 to size

menudlp	ldy #stmenuXsize-1
-		lda (datzptr),y
		ldx #tickcol	;tick-mark colours
		cpy #39
		beq +++
		cpy #12			;menu itself shouldn't be converted to ASCII
		bmi ++
		beq +
		ldx #bordcol	;border color of menu
+		cpy #25
		bmi ++
+		ldx #featcol	;features' text colour at menu-area
		jsr convASCII
+		sta (vidzptr),y	;write characters
		txa
		sta (inszptr),y	;colourize
		dey
		bpl -
		lda datzptr+0
		clc
		adc #stmenuXsize
		sta datzptr+0
		bcc +
		inc datzptr+1
+		jsr nextrow

		dec zpvari2
		bpl menudlp

		ldy #33
-		lda rastitext,y
		jsr convASCII
		sta lowvidram+22*40+3,y
		lda #11
		sta COLRPOS+22*40+3,y
		dey
		bpl -

		rts

setmrow1 ;set screen pointers to menu and zpvari2 to size
		lda #<lowvidram+menumempos
		ldx #>lowvidram+menumempos
		sta vidzptr+0
		stx vidzptr+1
		lda #<COLRPOS+menumempos
		ldx #>COLRPOS+menumempos
		sta inszptr+0
		stx inszptr+1
		ldx #stmenuYsize-1
		stx zpvari2
		rts

nextrow	;increase videoRAM & colourRAM pointers by 40
		lda vidzptr+0
		clc
		adc #40
		sta vidzptr+0
		lda inszptr+0
		clc
		adc #40
		sta inszptr+0
		bcc +
		inc vidzptr+1
		inc inszptr+1
+		rts

;--------------------------------------------------------
ColMenuPt ;colourize menu-points based on selection
		dec sfadecnt
		bne colsele
		lda #sfadespd
		sta sfadecnt
		ldx #3
-		lda scolcnt,x
		cmp #fademin
		beq +
		dec scolcnt,x
+		tay
		lda BrightCol,y
		jsr colpont
		dex
		bpl -

colsele	ldx selection
		lda BrightCol+fademax

colpont	pha ;input: X=number of menupoint, A=color to it
		lda scolpos1,x 
		sta vidzptr+0
		lda scolpos2,x
		sta vidzptr+1
		pla
		ldy #7
-		sta (vidzptr),y
		dey
		bpl -
colmret	rts

resetsfade
		ldx selection
		lda #fademax
		sta scolcnt,x
		rts

;----------------------------------
playertxt
		ldy scrollcnt
		cpy #40
		beq pltxend
		inc scrollcnt
		ldx #0
-		lda lowvidram+19*40+1,x
		sta lowvidram+19*40+0,x
		lda lowvidram+20*40+1,x
		sta lowvidram+20*40+0,x
		inx
		cpx #39
		bne -
		lda selection
		asl
		tax
		lda altplayers.descrAddr+0,x
		sta datzptr+0
		lda altplayers.descrAddr+1,x
		sta datzptr+1
		lda (datzptr),y
putscrl	jsr convASCII
		sta lowvidram+19*40+39
		tya
		clc
		adc #40
		tay
		lda (datzptr),y
		jsr convASCII
		sta lowvidram+20*40+39
pltxend	rts

scrollcnt .byte 0

;----------------------------------
convASCII	;convert ASCII to PETSCII lowercase
		cmp #$60
		bmi +
		and #$9F
+		rts

;--------------------------------------
CopyFeat ;copy player-features to the main code
		lda selection
		asl
		tax
		lda altplayers.FeatIadd+0,x
		sta datzptr+0
		lda altplayers.FeatIadd+1,x
		sta datzptr+1
		ldy #(FeatInstances_end-FeatInstance1)-1
-		lda (datzptr),y
wrFeat	sta FeatInstance1,y
		dey
		bpl -
		rts

;----------------------------------------------------
doSkewy	;skew letters to italic with $d016
		cmp $d012
		bcs *-3
		lda #15
		sta $d016
		ldy #10 ;for PAL
		lda PALNTSC
		bne +
		ldy #11 ;for NTSC
+		dey
		bne *-1
		ldx #6
skewLop	lda skewset,x
		sta $d016
		ldy #10
		dey
		bne *-1
		dex
		bpl skewLop
		nop
		rts

;-------------------------------------
DispFeat ;display feature-signals
		jsr setmrow1 ;set screen pointers & zpvari2
		ldx #0 ;counts rows
-		lda #"z" ;check-mark (tick)
		ldy FeatInstance1,x
		bne +
		lda #" " ;space (lack of tick)
+		ldy #tickColumn1
		sta (vidzptr),y
		lda #"z" ;check-mark (tick)
		ldy FeatInstance2,x
		bne +
		lda #" " ;space (lack of tick)
+		ldy #tickColumn2
		sta (vidzptr),y
		jsr nextrow
		inx
		dec zpvari2
		bpl -

		lda selection
		asl
		asl
		tay
		ldx #0
-		lda altplayers.rastimes,y
		sta lowvidram+22*40+15,x
		lda altplayers.plysizes,y
		sta lowvidram+22*40+33,x
		iny
		inx
		cpx #4
		bne -

		rts

;--------------------------- literals, variables -------------------------------

selection .byte 0 ;the currently selected menupoint 0..3
norepeat .byte 0 ;if value is 0, repeat is disabled

titletx	.text"      SID-WIZARD ",SWversion,"  STARTUP-MENU      ","  "
selectx	.text"  Please select your preferred player:  "
machitx	.text" PAL machine detected, pitches adjusted."
NTSCtx	.text"NTSC"

menugraph .text"TransposeFX z  oooooooooo   HR. types  z"
menurow1  .text"Inst.Octave z  t        j  Frame1-cfg. z"
          .text"Chord-Table z  t NORMAL j  Tempo-prog. z"
          .text"CalcVibrato z  t        j  Tempos 0..2 z"
          .text"VibratoType z  t MEDIUM j  Delayer-FX. z"
          .text"DetuneTable z  t        j  SubtuneJump z"
          .text"Portam+vibr z  t LIGHT  j  SaveZeroPg. z"
          .text"WFARP speed z  t        j  Ghost-regs. z"
          .text"NoteOFF ptr z  t EXTRA  j  11bit filt. z"
          .text"PW/Fi.reset z  t        j  Filt-CTL.FX z"
          .text"Keybd.track z  wwwwwwwwww  No tbl.skip z"
menuend
rastitext .text"RasterTime: $1C  Player-Size: $A00"

menumempos=40*stmenuYpos+stmenuXpos
stmenuXsize=menurow1-menugraph
stmenuYsize=(menuend-menugraph)/stmenuXsize

scolpos1 .byte <(COLRPOS+menumempos+40*2+mnptpos),<(COLRPOS+menumempos+40*4+mnptpos),<(COLRPOS+menumempos+40*6+mnptpos),<(COLRPOS+menumempos+40*8+mnptpos)
scolpos2 .byte >(COLRPOS+menumempos+40*2+mnptpos),>(COLRPOS+menumempos+40*4+mnptpos),>(COLRPOS+menumempos+40*6+mnptpos),>(COLRPOS+menumempos+40*8+mnptpos)
scolcnt	 .byte fademax,fademax,fademax,fademax ;fader colour-counters for the menupoints
sfadecnt .byte sfadespd

BrightCol .byte $00,$99,$66,$BB,$22,$44,$88,$CC,$EE,$55,$AA,$FF,$33,$DD,$77,$11 ;C64 colours in order of brightness (from darkest to brightest)
ColBright .byte 0,15,4,12,5,9,2,14,6,1,10,3,7,13,8,11 ;pace of C64 colours on brightness-scale
colcnt .byte 15		;color-fader's colour-counter
fadespcnt .byte fadespd ;colour-fader speed-counter

skewset	.byte 8,9,10,11,12,13,14,15

.bend	;end of Startupmenu-block


;=============================================================================================================
